local achId, achName, achImage = ...

local ActionHelper = include("ActionHelper")

local menuScale = game.menuScale()
local px = game.windowSizeX() * 0.5
local py = -64*menuScale
local basePriority = 125
local timer = 0
local timerReset = false
local successGfx

local AchievementComplete = {}

local obj = game.GetGameWorld():createGameObject("GameObject");
obj:setTag("AchievementNotification")
obj:setPos( px, py )

local bgGfx = obj:addSpriteSheet( "xml_resources/sprite_menu.xml", "box_small", 0 ,0, menuScale, menuScale )

bgGfx:SetLayerByName("HUD")
bgGfx:SetPriority(basePriority)
bgGfx:center()

AchievementComplete.gameobject = obj


local function waitForMessage()
	print ("SAchievmement Wait For Message")
	-- pull this out so it doesn't get rebuilt every time this is called
	coroutine.yield({		
		game.engineReceiver(), 
		game.M_MsgFacebookAchievement_GetMsgTypeId(),
		function(msg)
			print ("MsgFacebookAchievement")
			if(msg.result == true ) then
				print "Successfully Published Achievement"
				AchievementComplete.facebookButton:hide()
				local successGfx = AchievementComplete.gameobject:addSpriteSheet( "xml_resources/sprite_menu.xml", "btn_facebook_chked", bgGfx:width()*menuScale/2 - 75*menuScale, 0, menuScale, menuScale )
				successGfx:SetPriority(basePriority-10)
				successGfx:center()
				successGfx:SetLayerByName("HUD")
			else
				print "Failed to Published Achievement"
				--AchievementComplete.facebookButton:enable()
			end
			
			
		end,
		
		game.engineReceiver(), 
		game.M_MsgTweetStatus_GetMsgTypeId(),
		function(msg)
			print ("MsgTweetStatus result: "..msg.result_)
			if(msg.result_ == 1 ) then
				print "Successfully Published Achievement to Twitter"
				AchievementComplete.twitterButton:hide()
				local successGfx = AchievementComplete.gameobject:addSpriteSheet( "xml_resources/sprite_menu.xml", "btn_twitter_chked", bgGfx:width()*menuScale/2 - 25*menuScale, 0, menuScale, menuScale )
				successGfx:SetPriority(basePriority-10)
				successGfx:center()
				successGfx:SetLayerByName("HUD")
			else
				print "Failed to Published Achievement  to Twitter"
				--AchievementComplete.twitterButton:enable()
			end
			
			
		end,
		
		game.engineReceiver(), 
		game.M_MsgUpdate_GetMsgTypeId(),
		function(msg) 
			timer = timer + msg.time
			if( timer >= 5.0 ) then
				return true
			else 
				return false
			end
		end
	})
end

local text = game.getLocalizedText(achName)

local textGfx
local tempObj = game.GetGameWorld():createGameObject("GameObject")
local scale = 0.6*menuScale
local tempGfx = tempObj:addTextRaster(game.getDescriptionFont(), text, 0, 0, scale, scale, game.GfxText_Format_Left, 150*menuScale, true )

if(tempGfx:numLines() == 1) then
	textGfx = obj:addTextRaster(game.getDescriptionFont(), text, 0, 0, scale, scale, game.GfxText_Format_Left, 150*menuScale, true )
elseif(tempGfx:numLines() == 2) then
	textGfx = obj:addTextRaster(game.getDescriptionFont(), text, 0, -8*menuScale, scale, scale, game.GfxText_Format_Left, 150*menuScale, true )
else
	textGfx = obj:addTextRaster(game.getDescriptionFont(), text, 0, -14*menuScale, scale, scale, game.GfxText_Format_Left, 150*menuScale, true )
end

textGfx:SetLayerByName("HUD")
textGfx:SetPriority(basePriority-5)
textGfx:center()

local achievementGfx = obj:addSprite( achImage, -bgGfx:width()*menuScale/2 + 30, 0, 0.25*menuScale, 0.25*menuScale )
achievementGfx:SetLayerByName("HUD")
achievementGfx:SetPriority(basePriority)
achievementGfx:center()

--Facebook
local buttonFacebook = Button.new("xml_resources/sprite_menu.xml", "btn_facebook", "HUD", basePriority-3, obj, bgGfx:width()*menuScale/2 - 80, 0, true, menuScale)
buttonFacebook.gameobject:setTag("buttonFacebook")
buttonFacebook.onTouchUp = function()
	if timerReset == false then
		timer = 0
		timerReset = true
	end
	buttonFacebook:disable()
	game.submitAchievement(achId)
end

AchievementComplete.facebookButton = buttonFacebook

--Twitter
local buttonTwitter = Button.new("xml_resources/sprite_menu.xml", "btn_twitter", "HUD", basePriority-3, obj, bgGfx:width()*menuScale/2 - 30, 0, true, menuScale)
buttonTwitter.gameobject:setTag("buttonTwitter")
buttonTwitter.onTouchUp = function()
	if timerReset == false then
		timer = 0
		timerReset = true
	end
	buttonTwitter:disable()
	local tweetText = game.getLocalizedText("ACHIEVEMENT_TWEET")
	tweetText = select( 1, tweetText:gsub("XXX", text) )
	
	print(tweetText)
	game.sendTweet( tweetText, "data/"..achImage)
end

AchievementComplete.twitterButton = buttonTwitter
	
	
local action = obj:movePosition( 0, 100*menuScale, 0.5, lua_sys.Back_EASEOUT )
action:start()
ActionHelper.waitForAction(action)

waitForMessage()

--[[action = obj:wait(5.0)
action:start()
ActionHelper.waitForAction(action)]]

action = obj:movePosition( 0, -100*menuScale, 0.5, lua_sys.Back_EASEIN )
action:start()
ActionHelper.waitForAction(action)

game.GetGameWorld():destroyGameObject(obj)