inStore = ...

local ActionHelper = include("ActionHelper")
local Button = include("Button")
local StorePurchasePopup = include("StorePurchasePopup")

local menuScale = game.menuScale()

local BuyPremiumPopup = {}

local function waitForMessage()
	coroutine.yield({
		game.engineReceiver(),
		game.M_MsgBoughtCurrency_GetMsgTypeId(),
		function(msg)
			print("You Bought: " .. msg.name_ .. " valued: " .. msg.amount_)
			if( inStore == 0 ) then
				game.addPlatinumCoins(msg.amount_)
				game.purchasedCoins()
			end
		end,
		
		game.gameReceiver(), 
		game.M_MsgKillCoroutine_GetMsgTypeId(),
		function(msg)
			local ROUTINE = "BuyPremiumPopup"
			if (msg.menu == ROUTINE) then
				print("Killing "..ROUTINE.." Routine...")
				return true
			end
		end

	})
end

BuyPremiumPopup.show = function()
	--All the generic stuff
	local basePriority = 30

	local obj = game.GetGameWorld():createGameObject("GameObject");
	obj:setTag("BuyPremiumPopup")
	
	local textObj = game.GetGameWorld():createGameObject("GameObject");
	textObj:setTag("BuyPremiumPopupText")
	
	local fadedBGObj = game.GetGameWorld():createGameObject("GameObject");
	fadedBGObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	fadedBGObj:setTag("FadedBG2")
	
	local fadedBG = fadedBGObj:addSprite("gfx/menu/bg/background")
	fadedBGObj:setScale( lua_sys.screenWidth()/fadedBG:width(), lua_sys.screenHeight()/fadedBG:width() )
	fadedBG:SetLayerByName("POPUP")
	fadedBG:center()
	fadedBG:SetPriority(basePriority)
	fadedBG:SetAlpha(200)
	
	local touch = obj:addTouch( lua_sys.screenWidth(), lua_sys.screenHeight(), basePriority )
	touch:setAnchor( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	touch:setEnabled(1)

	local titleText = game.getLocalizedText("PREMIUM_STORE")
	local infoText = "TUTORIAL_COINS"
	
	local bg = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_large", 0, 0, menuScale, menuScale)
	bg:SetLayerByName("POPUP")
	bg:center()
	bg:SetPriority(basePriority-1)
	
	local title = textObj:addTextRaster("zombie_font_description", game.getLocalizedText(titleText), 0, -bg:height()*menuScale/2, 0.8*menuScale, 0.8*menuScale, game.GfxText_Format_Center, 355*menuScale, true )
	title:SetLayerByName("POPUP")
	title:center()
	title:SetPriority(basePriority-2)
	
	local closeButton = Button.new("xml_resources/sprite_menu.xml", "btn_close", "POPUP", basePriority-2, obj, -175*menuScale, -bg:height()*menuScale * 0.5 + 3*menuScale, true, menuScale)
	closeButton.onTouchUp = function() 
		BuyPremiumPopup.hide()
	end
	
	
	local items = game.getStoreItems(7)
	
	local i_posY = -bg:height()*menuScale * 0.1
	local i_posX = -bg:width()*menuScale * 0.3
	local posY = i_posY
	local posX = i_posX
	local spacingY = 75*menuScale
	local spacingX = 110*menuScale
	local pos = 0

	for i = 0, items:size()-1, 1 do
		local item = items[i];
		local group = items[i].itemGroupName_
		pos = pos + 1
		if (group ~= "convert" and item.platinumValue_ > 0) then
			local price = 0
			if (item.goldValue_ <= 0) then
				price = item.platinumValue_
			else
				price = item.goldValue_
			end

			if (item.showInStore_) then

				--local storeitem = StoreItem.new( item, "HUD", basePriority-2, obj, offsetX, offsetY)
				local textGfx = obj:addTextRaster("zombie_font_description", "+"..item.stack_, posX-20*menuScale, posY-(50+3)*menuScale, 0.7*menuScale, 0.7*menuScale, game.GfxText_Format_Left, 100*menuScale)
				textGfx:SetLayerByName("POPUP")
				textGfx:SetPriority(basePriority-3)
				
				local moneyIcon = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "coin_platinum", posX-35*menuScale, posY-40*menuScale)
				moneyIcon:SetLayerByName("POPUP")
				moneyIcon:SetPriority(basePriority-4)
				moneyIcon:center()
				item.moneyIcon = moneyIcon
				
				local fakeItem = {}
				fakeItem.category = item.category_
				fakeItem.id = item.id_
				
				local purchaseBtn = Button.new("xml_resources/sprite_menu.xml", "btn_green", "POPUP", basePriority-2, obj, posX, posY, true, menuScale)
				purchaseBtn:setText("$" .. (price/100))
				purchaseBtn.onTouchUp = function() 
					local storepurchasepopup = StorePurchasePopup.new(price, obj, fakeItem, 0, true, "", true, item)
					--BuyPremiumPopup.hide()
				end
				
				posX = posX + spacingX
				
				print ("Pos: "..pos)
				if ((pos) % 3 == 0) and (pos > 0) then
					posY = posY + spacingY
					posX = i_posX
				end
				
			end
		end
	end
	
	
	
	
	
	
	--Animate in
	textObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	textObj:setAlpha(0.0)
	
	obj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	obj:setScale(0.0, 1.0)
	
	local action = obj:moveScale( 1.0, 0, 0.45, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)

	action = textObj:moveAlpha( 1.0, 0.15, lua_sys.Quadratic_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
	
	waitForMessage()
end

BuyPremiumPopup.hide = function()

	local obj = game.GetGameWorld():getObjectByTag("BuyPremiumPopup")
	local textObj = game.GetGameWorld():getObjectByTag("BuyPremiumPopupText")
	local fadedBGObj = game.GetGameWorld():getObjectByTag("FadedBG2")
	if obj then
		local action = textObj:moveAlpha( -1.0, 0.1, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		
		if fadedBGObj then
			game.GetGameWorld():destroyGameObject(fadedBGObj)
		end
	
		action = obj:moveScale( -1.0, 0, 0.25, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		
		game.GetGameWorld():destroyGameObject(textObj)
		game.GetGameWorld():destroyGameObject(obj)
	end

	game.killCoroutine("BuyPremiumPopup")
end

BuyPremiumPopup.show()
--return BuyPremiumPopup