local obj = ...
local ActionHelper = include("ActionHelper")
local px = game.windowSizeX() * 0.5
local py = -64
local action = nil
local action2 = nil
local pause = false
local text = game.getLocalizedText("RESULT_SCREEN_GOOD_JOB")
local bonusTitleObj
local distanceTitleObj
local bonusObjects
local homerunMsgObj
local scoreboardObj
local amazingHomeRun = false
local levelId = game.getLevelId()
local flyBonusesToScore = true

local basePriority = 150

local menuScale = game.menuScale()

action = obj:wait(1.0)
action:start()
ActionHelper.waitForAction(action)

-- have a different check for each challenge?
local roundScore

if (levelId == 0 or levelId == 4) then
	roundScore = game.getFinalDistance()
else 
	roundScore = game.getRoundScore()
end
print ("roundScore "..roundScore)

--[[
--SAN FRANCISCO
if (levelId == 0 or levelId == 4) then
	if( roundScore < 0 ) then
		if( game.numConsecutiveHomeRuns() == 2) then
			text = game.getLocalizedText("RESULT_SCREEN_YOURE_ON_FIRE")
		elseif( roundScore < -100 ) then 
			text = game.getLocalizedText("RESULT_SCREEN_AMAZING_HOME_RUN")
			amazingHomeRun = true
		elseif( roundScore < -50 ) then 
			text = game.getLocalizedText("RESULT_SCREEN_GREAT_HOME_RUN")
		else
			text = game.getLocalizedText("RESULT_SCREEN_HOME_RUN")
		end
	elseif( roundScore < 10 and roundScore >= 0 ) then
		text = game.getLocalizedText("RESULT_SCREEN_SO_CLOSE")
	else
		text = game.getLocalizedText("RESULT_SCREEN_NICE_TRY")
	end
--CHICAGO
elseif( levelId == 1 or levelId == 3 ) then
	if( roundScore <= 0 ) then
		text = game.getLocalizedText("RESULT_SCREEN_NICE_TRY")
	elseif( roundScore > 0 and roundScore < 10 ) then
		text = game.getLocalizedText("RESULT_SCREEN_GOOD_JOB")
	else
		text = game.getLocalizedText("RESULT_SCREEN_AMAZING")
	end
-- ATLANTA
elseif( levelId == 2 ) then
	if( roundScore <= 0 ) then
		text = game.getLocalizedText("RESULT_SCREEN_NICE_TRY")
	else
		text = game.getLocalizedText("RESULT_SCREEN_AMAZING")
	end
-- LA
end--]]

if (game.playersTurn()) then
	text = game.getLocalizedText("YOUR_RESULTS")
else
	text = game.getLocalizedText("CHALLENGER_RESULTS")
end

action = obj:moveAlpha( 1.0, 0.15, lua_sys.Quadratic_EASEOUT )
action:start()
ActionHelper.waitForAction(action)
	
homerunMsgObj = game.GetGameWorld():createGameObject("GameObject");
homerunMsgObj:setParent(obj)
homerunMsgObj:setPos( px, py )

distanceTitleObj = game.GetGameWorld():createGameObject("GameObject");
distanceTitleObj:setParent(obj)

bonusTitleObj = game.GetGameWorld():createGameObject("GameObject");
bonusTitleObj:setParent(obj)

bonusObjects = game.GetGameWorld():createGameObject("GameObject");
bonusObjects:setParent(obj)

scoreboardObj = game.GetGameWorld():createGameObject("GameObject");
scoreboardObj:setParent(obj)

local bonusesCollected = game.getBonuses()
local numBonuses = bonusesCollected:size()
local targetPosX = game.windowSizeX() * 0.5
local targetPosY = 50*menuScale
local width = 64*menuScale
local totalWidth = width * numBonuses
local curPosX = targetPosX - (numBonuses-1)*(width*0.5)
local bonusObjStartPosY = 64*menuScale

local bonuses = {}
for i = 0, numBonuses-1 do
	local bonusObj = game.GetGameWorld():createGameObject("GameObject");
	bonusObj:setParent(bonusObjects)
	
	bonusObj:setPos(curPosX, -bonusObjStartPosY)
	
	bonuses[i] = {}
	bonuses[i].obj = bonusObj
	bonuses[i].targetPosX = 0
	bonuses[i].targetPosY = targetPosY
	bonuses[i].animName = bonusesCollected[i]
			
	curPosX = curPosX + width
end

-- CHALLENGE MESSAGE
px = game.windowSizeX() * 0.5
py = -64*menuScale
local gfx = homerunMsgObj:addTextRaster( game.getMidSizeFont(), text, 0, 0, 0.85*menuScale, 0.85*menuScale, game.GfxText_Format_Center )
gfx:SetLayerByName("HUD")
gfx:SetPriority(basePriority-2)
gfx:center()

local targetY = lua_sys.screenHeight()*0.5 + 64*menuScale - gfx:height()*menuScale * 0.5
if (amazingHomeRun == true) then
	targetY = targetY - gfx:height()*menuScale * 0.5
end
action = homerunMsgObj:movePosition( 0, targetY, 0.5, lua_sys.Back_EASEOUT )
action:start()
ActionHelper.waitForAction(action)

action = homerunMsgObj:wait(0.3)
action:start()
ActionHelper.waitForAction(action)

-- ROUND SCORE
px = -game.windowSizeX()*0.5
py = game.windowSizeY() * 0.5 + 20*menuScale
local text 
if( levelId == 0 or levelId == 4) then
	text = game.getLocalizedText("RESULT_SCREEN_DISTANCE")
	text = select( 1, text:gsub("XXX", math.floor(game.getFinalDistance())) )
	
	if( math.floor(roundScore) == 0 ) then
		flyBonusesToScore = false
	end
elseif( levelId == 1 ) then
	text = game.getLocalizedText("RESULTS_HOTDOG")
	text = select( 1, text:gsub("XXX", math.floor(roundScore)) )
	if( math.floor(roundScore) == 0 ) then
		flyBonusesToScore = false
	end
elseif( levelId == 2 ) then
	-- Collected Trophy
	if( roundScore == 1 ) then
		text = game.getLocalizedText("RESULT_TROPHY")
		text = select( 1, text:gsub("XXX", roundScore) )
	else
		text = game.getLocalizedText("RESULT_SCREEN_DISTANCE")
		text = select( 1, text:gsub("XXX", math.floor(game.getFinalDistance())) )
		flyBonusesToScore = false
	end
elseif( levelId == 3 ) then
	text = game.getLocalizedText("RESULT_COINS")
	text = select( 1, text:gsub("XXX", math.floor(roundScore)) )
	if( math.floor(roundScore) == 0 ) then
		flyBonusesToScore = false
	end
end


distanceTitleObj:setPos( px, py )
local ditanceTitleText = distanceTitleObj:addTextRaster( game.getDescriptionFont(), text, 0, 0, 0.7*menuScale, 0.7*menuScale, game.GfxText_Format_Center)
ditanceTitleText:SetLayerByName("HUD")
ditanceTitleText:SetPriority(basePriority-2)
ditanceTitleText:center()

game.playSfx("audio/sfx/woosh2.wav")
action = distanceTitleObj:movePosition( game.windowSizeX(), 0, 0.5, lua_sys.Back_EASEOUT )
action:start()
ActionHelper.waitForAction(action)

-- add current distance to score
if (not flyBonusesToScore ) then

	if( math.floor(roundScore) > 0 ) then
		game.playSfx("audio/sfx/collect_powerup.wav")
	end
	
	game.addDistanceToScore()
end

-- BONUS TITLE
if (numBonuses > 0 ) then

	text = game.getLocalizedText("BONUSES")

	local bonusTitleText = bonusTitleObj:addTextRaster( game.getDescriptionFont(), text, 0, 0, 0.7*menuScale, 0.7*menuScale)
	bonusTitleText:SetLayerByName("HUD")
	bonusTitleText:SetPriority(basePriority-2)
	bonusTitleText:center()

	px = game.windowSizeX()+bonusTitleText:width()*menuScale
	py = distanceTitleObj:y() + 40*menuScale
	bonusTitleObj:setPos( px, py )

	game.playSfx("audio/sfx/woosh2.wav")
	action = bonusTitleObj:movePosition( -game.windowSizeX()*0.5 - bonusTitleText:width()*menuScale, 0, 0.7*menuScale, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)


	for i=0, table.getn(bonuses) do
		local objB = bonuses[i].obj
		local bonusSprite = objB:addSpriteSheet("xml_resources/bb_icons.xml", bonuses[i].animName )
		bonusSprite:SetLayerByName("HUD")
		bonusSprite:center()
		bonusSprite:SetPriority(basePriority-2)
		
		game.playSfx("audio/sfx/woosh2.wav")		
		action = objB:movePosition( 0, bonusTitleObj:y()+bonuses[i].targetPosY+bonusSprite:height()*menuScale, 0.5, lua_sys.Back_EASEOUT )
		action:start()
		ActionHelper.waitForAction(action)
		
		-- apply bonus to score if not in Atlanta Challenge
		if( levelId ~= 2 ) then
			if( not flyBonusesToScore ) then
				game.applyBonus(i)
			end
		end
	end
end

action = obj:wait(0.7)
action:start()
ActionHelper.waitForAction(action)

if (flyBonusesToScore) then

	game.playSfx("audio/sfx/woosh2.wav")
	--score
	if (game.playersTurn()) then
		action = distanceTitleObj:movePosition( -game.windowSizeX(), -game.windowSizeY(), 0.6, lua_sys.Back_EASEIN )
	else
		action = distanceTitleObj:movePosition( -game.windowSizeX(), game.windowSizeY(), 0.6, lua_sys.Back_EASEIN )
	end
	action:start()
	ActionHelper.waitForAction(action)
	game.addDistanceToScore()
	game.playSfx("audio/sfx/collect_powerup.wav")
	
	--bonuses
	if (numBonuses > 0 ) then
		for i=0, table.getn(bonuses) do
			local objB = bonuses[i].obj

			game.playSfx("audio/sfx/woosh2.wav")
			if (game.playersTurn()) then
				action = objB:movePosition( -game.windowSizeX(), -game.windowSizeY(), 0.6, lua_sys.Back_EASEIN )
			else
				action = objB:movePosition( -game.windowSizeX(), game.windowSizeY(), 0.6, lua_sys.Back_EASEIN )
			end
			--action = objB:movePosition( 0, bonusTitleObj:y()+bonuses[i].targetPosY+bonusSprite:height(), 0.5, lua_sys.Back_EASEOUT )
			action:start()
			ActionHelper.waitForAction(action)
			game.playSfx("audio/sfx/collect_powerup.wav")
			
			-- apply bonus to score if not in Atlanta Challenge
			if( levelId ~= 2 ) then
				game.applyBonus(i)
			end
		end
	end
end

action = obj:wait(0.7)
action:start()
ActionHelper.waitForAction(action)

local bgGfx = scoreboardObj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_medium", 0, 0, 0.8*menuScale, 1.2*menuScale)
bgGfx:SetLayerByName("HUD")
bgGfx:SetPriority(basePriority-1)
bgGfx:center()

-- player avatar
local avatarGfx
if (game.getSelectedCharacter() == 1) then
	avatarGfx = scoreboardObj:addSpriteSheet("xml_resources/sprite_menu.xml", "head_sam", -80*menuScale, -30*menuScale, 0.9*menuScale, 0.9*menuScale)
else
	avatarGfx = scoreboardObj:addSpriteSheet("xml_resources/sprite_menu.xml", "head_buster", -80*menuScale, -30*menuScale, 0.9*menuScale, 0.9*menuScale)
end
avatarGfx:SetLayerByName("HUD")
avatarGfx:SetPriority(basePriority-2)
avatarGfx:center()



-- challenger avatar
avatarGfx = scoreboardObj:addSpriteSheet("xml_resources/sprite_menu.xml", "head_challenger_0"..game.getLevelId(), 80*menuScale, -30*menuScale, 0.9*menuScale, 0.9*menuScale)
avatarGfx:SetLayerByName("HUD")
avatarGfx:SetPriority(basePriority-2)
avatarGfx:center()

local vsText = scoreboardObj:addTextRaster( game.getDescriptionFont(), game.getLocalizedText("VS"), 0, 0)
vsText:SetLayerByName("HUD")
vsText:SetPriority(basePriority-2)
vsText:center()

-- player score
local scoreGfx = scoreboardObj:addTextRaster( game.getMidSizeFont(), game.getScore(), -80*menuScale, 20*menuScale, menuScale*0.45, menuScale*0.45, game.GfxText_Format_Center )
scoreGfx:SetLayerByName("HUD")
scoreGfx:SetPriority(basePriority-2)
scoreGfx:center()

-- challenger score
scoreGfx = scoreboardObj:addTextRaster( game.getMidSizeFont_red(), game.getScore(false), 80*menuScale, 20*menuScale, menuScale*0.45, menuScale*0.45, game.GfxText_Format_Center )
scoreGfx:SetLayerByName("HUD")
scoreGfx:SetPriority(basePriority-2)
scoreGfx:center()

scoreboardObj:setPos( game.windowSizeX()+game.windowSizeX()*0.5, game.windowSizeY()*0.5 )

game.playSfx("audio/sfx/woosh2.wav")
action = obj:movePosition( -game.windowSizeX(), 0, 0.5, lua_sys.Back_EASEOUT )
action:start()

game.playSfx("audio/sfx/woosh2.wav")
--action2 = scoreboardObj:movePosition( 0, 0, 0.5, lua_sys.Back_EASEOUT )
--action2:start()
ActionHelper.waitForAction(action)
--ActionHelper.waitForAction(action2)

action = obj:wait(1.0)
action:start()
ActionHelper.waitForAction(action)

game.playSfx("audio/sfx/woosh2.wav")
action = scoreboardObj:movePosition( -game.windowSizeX(), 0, 0.5, lua_sys.Quadratic_EASEIN )
action:start()
ActionHelper.waitForAction(action)

game.GetGameWorld():destroyGameObject(scoreboardObj)

game.gameReceiver():Send(game.MsgContinueGame())


