
local ActionHelper = include("ActionHelper")
local Button = include("Button")
--local PopupStatInfo = include("PopupStatInfo")

local menuScale = game.menuScale()

local ConvertPlatinumPopup = {}

ItemCategory = {
	["HAT"] = 0,
	["GLOVE"] = 1,
	["BAT"] = 2,
	["SHIRT"] = 3,
	["PANTS"] = 4,
	["SHOES"] = 5,
	["POWERUP"] = 6,
	["CURRENCY"] = 7
}

ConvertPlatinumPopup.new = function( item, data, parent )

	local obj = game.GetGameWorld():createGameObject("GameObject");
	obj:setTag("ConvertPlatinumPopup")

	local basePriority = 20

	local fadedBGObj = game.GetGameWorld():createGameObject("GameObject");
	--fadedBGObj:setParent(parent)
	fadedBGObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	fadedBGObj:setTag("FadedBG_SPP")
	
	local fadedBG = fadedBGObj:addSprite("gfx/menu/bg/background")
	fadedBGObj:setScale( lua_sys.screenWidth()/fadedBG:width(), lua_sys.screenHeight()/fadedBG:width() )
	fadedBG:SetLayerByName("POPUP")
	--fadedBG:SetScale(1.5, 1.5)
	fadedBG:center()
	--fadedBG:SetPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5)
	--fadedBG:SetPos( lua_sys.screenWidth() * 0.75, lua_sys.screenHeight() * 0.75)
	fadedBG:SetPriority(basePriority)
	fadedBG:SetAlpha(200)
	
	local bg = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_medium", 0, 0, menuScale, menuScale)
	bg:SetLayerByName("POPUP")
	bg:center()
	bg:SetPriority(basePriority-1)
	
	
	
	local icon = "coin_platinum"
	
	local moneyIcon = obj:addSpriteSheet("xml_resources/sprite_menu.xml", icon, -45*menuScale, 30*menuScale, menuScale, menuScale)
	moneyIcon:SetLayerByName("POPUP")
	moneyIcon:SetPriority(basePriority-4)
	moneyIcon:center()
	

	local closeButton = Button.new("xml_resources/sprite_menu.xml", "btn_close", "POPUP", basePriority-2, obj, -175*menuScale, -bg:height() * 0.5 *menuScale + 10*menuScale, true, menuScale)
	closeButton.onTouchUp = function() 
		ConvertPlatinumPopup.resume = true
		ConvertPlatinumPopup.hide()
	end

	local touch = obj:addTouch( lua_sys.screenWidth(), lua_sys.screenHeight(), basePriority )
	touch:setAnchor( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	touch:setEnabled(1)

	local priceObj = game.GetGameWorld():createGameObject("GameObject");
	priceObj:setTag("ConvertPlatinumPopupText")
	

	local descText = game.getLocalizedText("CONFIRM_CONVERT")
	descText = select( 1, descText:gsub("XXX", data.platinumValue_) )
	descText = select( 1, descText:gsub("YYY", data.stack_) )
	local textGfx = priceObj:addTextRaster("zombie_font_description", descText, 10*menuScale, -13*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Center, 300*menuScale, true )
	textGfx:SetLayerByName("POPUP")
	textGfx:center()
	textGfx:SetPriority(basePriority-2)
	
	
	nameText = priceObj:addTextRaster("zombie_font_description", item.name, 0, -38*menuScale, 0.6*menuScale, 0.6*menuScale, game.GfxText_Format_Center, 250*menuScale)
	nameText:SetLayerByName("POPUP")
	nameText:center()
	nameText:SetPriority(basePriority-3)
	
	
	local buyButton = Button.new("xml_resources/sprite_menu.xml", "btn_green", "POPUP", basePriority-2, obj, 0, bg:height()*menuScale * 0.30*menuScale, true, menuScale)
	buyButton:setText("" .. data.platinumValue_)
	buyButton.onTouchUp = function() 
		--[[if (item.category == ItemCategory["CURRENCY"]) then
			if ( game.buyRealItem(data.itemGroupName_, item.id) ) then
				ConvertPlatinumPopup.hide()
				--game.addPlatinumCoins( data.stack_ )
			end
			return
		end--]]
	
		if ( game.convertPlatinumToGold(data.platinumValue_, data.stack_) ) then			
			game.playSfx("audio/sfx/cash_register.wav");
			print("Purchasing item id[" .. item.id .. "] from category [" .. item.category .. "]")
			ConvertPlatinumPopup.hide()
		else
			print("Not enough currency to buy!")
			ConvertPlatinumPopup.hide()
			local inStore = 1
			game.showNoMoneyPrompt(inStore)			
		end
	end
	
	-- animate
	priceObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	priceObj:setAlpha(0.0)
	
	obj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	obj:setScale(0.0, 1.0)
	
	local action = obj:moveScale( 1.0, 0, 0.45, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)

	action = priceObj:moveAlpha( 1.0, 0.15, lua_sys.Quadratic_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
	
end

-- Animations to close the menu
ConvertPlatinumPopup.hide = function()

	local obj = game.GetGameWorld():getObjectByTag("ConvertPlatinumPopup")
	local textObj = game.GetGameWorld():getObjectByTag("ConvertPlatinumPopupText")
	local FadedBGObj = game.GetGameWorld():getObjectByTag("FadedBG_SPP")
	if obj then
		local action = textObj:moveAlpha( -1.0, 0.1, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
	
		action = obj:moveScale( -1.0, 0, 0.25, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		
		ConvertPlatinumPopup.timeLeft = 0
		game.GetGameWorld():destroyGameObject(textObj)
		game.GetGameWorld():destroyGameObject(FadedBGObj)
		game.GetGameWorld():destroyGameObject(obj)
	end
end

return ConvertPlatinumPopup

