local ActionHelper = include("ActionHelper")
local Button = include("Button")
local LeaderboardItem = include("LeaderboardItem")
local SwipeComponent = include("SwipeComponent")

local Friends = {}
Friends.connectToFacebook = 0

local function updateFacebookStat()

	print "update facebook status"
	local fbStatus = false
	while true do
		coroutine.yield({
			game.engineReceiver(), 
			game.M_MsgLoginFacebook_GetMsgTypeId(),
			function(msg) 
				print ("updating fb login status 1", msg.login)
				fbStatus = msg.login
				return true
			end
		})
		
		
		if( Friends.connectToFacebook == 1) then
			local friendObj = game.GetGameWorld():getObjectByTag("Friends")
			if( friendObj ) then
				game.GetGameWorld():destroyGameObject(friendObj)
			end
			
			print ("connecting to facebook"..Friends.connectToFacebook)
			Friends.show()
		end
		print "updating fb login status 2"
	end

end

RunCoroutine(updateFacebookStat)

Friends.show = function(tab, root)

	local obj = game.GetGameWorld():createGameObject("GameObject");
	obj:setTag("Friends")

	local basePriority = 100

	local offsetX = 0
	local offsetY = -120
	local spacingY = 75
	Friends.totalListHeight = 0
	
	local function addLeaderboardItem()
		print "function addLeaderboardItem"
		coroutine.yield({
			game.engineReceiver(), 
			game.M_MsgFacebookLeaderboardScores_GetMsgTypeId(),
			function(msg) 
				local pos = 1
				local lItem = nil
				for i = 0, msg.highscores:size()-1 do
					print (msg.highscores[i].name..","..msg.highscores[i].score..","..msg.highscores[i].fbid)
					lItem = LeaderboardItem.new(msg.highscores[i].name, msg.highscores[i].score, msg.highscores[i].fbid, pos, "HUD", basePriority-2, obj, offsetX, offsetY)
					lItem.onTouchUp = function()
						print "touch up leaderboarditem"
					end
	
					offsetY = offsetY + spacingY
					pos = pos + 1
					Friends.totalListHeight = Friends.totalListHeight +lItem.height + 11
					print ("function totalListHeight"..Friends.totalListHeight)
				end
	
				print ("function addLeaderboardItem 2")
				return true
			end })
	
		print ("function addLeaderboardItem 3: "..Friends.totalListHeight)
		
		local swipeComponentHeight = lua_sys.screenHeight() * math.ceil(Friends.totalListHeight/lua_sys.screenHeight())
		print ("swipeComponentHeight = "..swipeComponentHeight)
		if( swipeComponentHeight < lua_sys.screenHeight() ) then
			print ("swipeComponentHeight must be at least the height of the screen")
			swipeComponentHeight = lua_sys.screenHeight()
		end
		local swipeComp = SwipeComponent.new( lua_sys.screenWidth()-70, swipeComponentHeight, "HUD", basePriority-1, obj ) 
	
		local upperLimit = (lua_sys.screenHeight() * 0.5) - (Friends.totalListHeight - 300)
		print( "upperLimit"..upperLimit )
		if( upperLimit > lua_sys.screenHeight() * 0.5 ) then
			upperLimit = lua_sys.screenHeight() * 0.5
		end	
			
		swipeComp:setUpperLimit (upperLimit)
		Friends.swipeLayer = swipeComp;
	end
	
	
	if game.isConnectedToFacebook() == 1 then
		RunCoroutine(addLeaderboardItem)
		game.getFBHigscores()
	else
	
		local bg = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_medium")
		bg:SetLayerByName("HUD")
		bg:center()
		bg:SetPriority(basePriority)
	
		local closeButton = Button.new("xml_resources/sprite_menu.xml", "btn_close", "HUD", basePriority-2, obj, -175, -bg:height() * 0.5 + 10)
		closeButton.onTouchUp = function() 
			if tab then
				tab:toggle()
			end
		end
	
		local recommendText = obj:addTextRaster("zombie_font_description", "Login to Facebook", 0, -25, 0.6, 0.6)
		recommendText:SetLayerByName("HUD")
		recommendText:center()
		recommendText:SetPriority(basePriority-2)

		local shareButton = Button.new("xml_resources/sprite_menu.xml", "btn_blue", "HUD", basePriority-2, obj, 0, 10)
		shareButton:setText("Connect")
		shareButton.onTouchUp = function() 
			Friends.connectToFacebook = 1
			print ("start connecting to facebook"..Friends.connectToFacebook)
			game.toggleFacebook()
			
		end
	end
	
	
	obj:setPos( -lua_sys.screenWidth(), lua_sys.screenHeight() * 0.5 )
	
	local action = obj:movePosition( lua_sys.screenWidth() * 0.5 - 50 - obj:x(), 0, 1, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)

end

Friends.hide = function()

	local obj = game.GetGameWorld():getObjectByTag("Friends")
	if obj then
		local action = obj:movePosition( -lua_sys.screenWidth() - obj:x(), 0, 0.5, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		game.GetGameWorld():destroyGameObject(obj)
		
		print ("listheight"..Friends.totalListHeight)
		if( Friends.totalListHeight > 0 ) then
			SwipeComponent.destroy()
		end
	else
		print("Where'd options go?")
	end

end

return Friends