local tutId = ...

local ActionHelper = include("ActionHelper")
local Button = include("Button")

local HelpScreen = {}

local menuScale = game.menuScale()

HelpScreen.show = function(tutorialId, doAnimate)
	--All the generic stuff
	local basePriority = 20
	
	HelpScreen.doAnimate = doAnimate or false

	local obj = game.GetGameWorld():createGameObject("GameObject")
	obj:setTag("HelpScreen")
	obj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	
	local textObj = game.GetGameWorld():createGameObject("GameObject")
	textObj:setTag("HelpScreenText")
	
	local fadedBGObj = game.GetGameWorld():createGameObject("GameObject")
	fadedBGObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	fadedBGObj:setTag("FadedBG")
	
	local fadedBG = fadedBGObj:addSprite("gfx/menu/bg/background")
	fadedBGObj:setScale( lua_sys.screenWidth()/fadedBG:width(), lua_sys.screenHeight()/fadedBG:width() )
	fadedBG:SetLayerByName("HUD")
	fadedBG:center()
	fadedBG:SetPriority(basePriority)
	fadedBG:SetAlpha(200)
	
	local image = obj:addSprite("gfx/help/" .. tutorialId, 0, 0, menuScale, menuScale )
	image:SetLayerByName("POPUP")
	image:center()
	image:SetPriority(basePriority-1)
	
	local continueButton = Button.new("xml_resources/sprite_menu.xml", "btn_yellow", "POPUP", basePriority-10, obj, lua_sys.screenWidth()*0.5 - 60*menuScale, lua_sys.screenHeight()*0.5-20*menuScale, true, menuScale)
	continueButton.gameobject:setTag("ContinueButton")
	continueButton:setText("Continue")
	continueButton.onTouchUp = function() 
		HelpScreen.hide()
	end
	
	local touch = obj:addTouch( lua_sys.screenWidth(), lua_sys.screenHeight(), 19 )
	touch:setAnchor( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	touch:setEnabled(1)

	
	obj:setScale(0.0, 1.0)
	
	local action = obj:moveScale( 1.0, 0, 0.45, lua_sys.Back_EASEOUT )
	action:start()
end

HelpScreen.hide = function()

	local obj = game.GetGameWorld():getObjectByTag("HelpScreen")
	local textObj = game.GetGameWorld():getObjectByTag("HelpScreenText")
	local fadedBGObj = game.GetGameWorld():getObjectByTag("FadedBG")
	if obj then
		if (HelpScreen.doAnimate) then
			local action = obj:moveScale( -1.0, 0, 0.3, lua_sys.Quadratic_EASEIN )
			action:start()
			ActionHelper.waitForAction(action)
		end
		
		if fadedBGObj then
			game.GetGameWorld():destroyGameObject(fadedBGObj)
		end
	
		--action = obj:moveScale( -1.0, 0, 0.25, lua_sys.Quadratic_EASEIN )
		--action:start()
		--ActionHelper.waitForAction(action)
		
		game.GetGameWorld():destroyGameObject(textObj)
		game.GetGameWorld():destroyGameObject(obj)
		
		if (HelpScreen.onClose) then
			HelpScreen.onClose()
		end
	end

end

return HelpScreen