local obj = ...
local ActionHelper = include("ActionHelper")
local px = game.windowSizeX() * 0.5
local py = -64
local action = nil
local action2 = nil
local pause = false
local text = "NICE HOME RUN!"
local bonusTitleObj
local distanceTitleObj
local bonusObjects
local homerunMsgObj
local amazingHomeRun = false

local basePriority = 150

local menuScale = game.menuScale()

local finalDistance = game.getFinalDistance()
local distanceFromTarget = game.getDistanceFromTarget()
print ("distance from target "..distanceFromTarget)
if( distanceFromTarget < 0 ) then
	if( game.numConsecutiveHomeRuns() == 2) then
		text = game.getLocalizedText("RESULT_SCREEN_YOURE_ON_FIRE")
	elseif( distanceFromTarget < -100 ) then 
		text = game.getLocalizedText("RESULT_SCREEN_AMAZING_HOME_RUN")
		amazingHomeRun = true
	elseif( distanceFromTarget < -50 ) then 
		text = game.getLocalizedText("RESULT_SCREEN_GREAT_HOME_RUN")
	else
		text = game.getLocalizedText("RESULT_SCREEN_HOME_RUN")
	end
elseif( distanceFromTarget < 10 and distanceFromTarget >= 0 ) then
	text = game.getLocalizedText("RESULT_SCREEN_SO_CLOSE")
else
	text = game.getLocalizedText("RESULT_SCREEN_NICE_TRY")
end

action = obj:moveAlpha( 1.0, 0.15, lua_sys.Quadratic_EASEOUT )
action:start()
ActionHelper.waitForAction(action)
	
homerunMsgObj = game.GetGameWorld():createGameObject("GameObject");
homerunMsgObj:setParent(obj)
homerunMsgObj:setPos( px, py )

distanceTitleObj = game.GetGameWorld():createGameObject("GameObject");
distanceTitleObj:setParent(obj)

bonusTitleObj = game.GetGameWorld():createGameObject("GameObject");
bonusTitleObj:setParent(obj)

bonusObjects = game.GetGameWorld():createGameObject("GameObject");
bonusObjects:setParent(obj)

local bonusesCollected = game.getBonuses()
local numBonuses = bonusesCollected:size()
local targetPosX = game.windowSizeX() * 0.5
local targetPosY = 50*menuScale
local width = 64*menuScale
local totalWidth = width * numBonuses
local curPosX = targetPosX - (numBonuses-1)*(width*0.5)
local bonusObjStartPosY = 64*menuScale

local bonuses = {}
for i = 0, numBonuses-1 do
	local bonusObj = game.GetGameWorld():createGameObject("GameObject");
	bonusObj:setParent(bonusObjects)
	
	bonusObj:setPos(curPosX, -bonusObjStartPosY)
	
	bonuses[i] = {}
	bonuses[i].obj = bonusObj
	bonuses[i].targetPosX = 0
	bonuses[i].targetPosY = targetPosY
	bonuses[i].animName = bonusesCollected[i]
			
	curPosX = curPosX + width
end

-- HOME RUN MESSAGE
px = game.windowSizeX() * 0.5
py = -64*menuScale
local gfx = homerunMsgObj:addTextRaster( game.getMidSizeFont(), text, 0, 0, 0.85*menuScale, 0.85*menuScale, game.GfxText_Format_Center )
gfx:SetLayerByName("HUD")
gfx:SetPriority(basePriority-2)
gfx:center()

local targetY = lua_sys.screenHeight()*0.5 + 64*menuScale - gfx:height() * 0.5 * menuScale
if (amazingHomeRun == true) then
	targetY = targetY - gfx:height() * 0.5 * menuScale
end

game.playSfx("audio/sfx/woosh2.wav")
action = homerunMsgObj:movePosition( 0, targetY, 0.5, lua_sys.Back_EASEOUT )
action:start()
ActionHelper.waitForAction(action)

action = homerunMsgObj:wait(0.3)
action:start()
ActionHelper.waitForAction(action)

-- DISTANCE
px = -64*menuScale
py = game.windowSizeY() * 0.5 + 20 * menuScale
local text = game.getLocalizedText("RESULT_SCREEN_DISTANCE")
text = select( 1, text:gsub("XXX", math.floor(game.getFinalDistance())) )


distanceTitleObj:setPos( px, py )
local ditanceTitleText = distanceTitleObj:addTextRaster( game.getDescriptionFont(), text, 0, 0, 0.7*menuScale, 0.7*menuScale, game.GfxText_Format_Center)
ditanceTitleText:SetLayerByName("HUD")
ditanceTitleText:SetPriority(basePriority-2)
ditanceTitleText:center()

game.playSfx("audio/sfx/woosh2.wav")
action = distanceTitleObj:movePosition( game.windowSizeX()*0.5-px, 0, 0.5, lua_sys.Back_EASEOUT )
action:start()
ActionHelper.waitForAction(action)

-- add current distance to score
--game.addDistanceToScore()

action = obj:wait(1.0)
action:start()
ActionHelper.waitForAction(action)

-- BONUS TITLE
if (numBonuses > 0 ) then

	text = game.getLocalizedText("BONUSES")

	local bonusTitleText = bonusTitleObj:addTextRaster( game.getDescriptionFont(), text, 0, 0, 0.7*menuScale, 0.7*menuScale)
	bonusTitleText:SetLayerByName("HUD")
	bonusTitleText:SetPriority(basePriority-2)
	bonusTitleText:center()

	px = game.windowSizeX()+bonusTitleText:width()*menuScale
	py = distanceTitleObj:y() + 40*menuScale
	bonusTitleObj:setPos( px, py )

	game.playSfx("audio/sfx/woosh2.wav")
	action = bonusTitleObj:movePosition( -game.windowSizeX()*0.5 - bonusTitleText:width()*menuScale, 0, 0.7*menuScale, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)

	for i=0, table.getn(bonuses) do
		local objB = bonuses[i].obj
		local bonusSprite = objB:addSpriteSheet("xml_resources/bb_icons.xml", bonuses[i].animName, 0, 0, menuScale, menuScale )
		bonusSprite:SetLayerByName("HUD")
		bonusSprite:center()
		bonusSprite:SetPriority(basePriority-2)
		
		game.playSfx("audio/sfx/woosh2.wav")		
		action = objB:movePosition( 0, bonusTitleObj:y()+bonuses[i].targetPosY+bonusSprite:height()*menuScale, 0.5, lua_sys.Back_EASEOUT )
		action:start()
		ActionHelper.waitForAction(action)
		
		-- apply bonus to score
		game.applyBonus(i)
	end
end

game.playSfx("audio/sfx/woosh2.wav")
--score
action = distanceTitleObj:movePosition( -game.windowSizeX(), -game.windowSizeY(), 0.6, lua_sys.Back_EASEIN )
action:start()
ActionHelper.waitForAction(action)
game.addDistanceToScore()
game.playSfx("audio/sfx/collect_powerup.wav")

--bonuses
if (numBonuses > 0 ) then
	for i=0, table.getn(bonuses) do
		local objB = bonuses[i].obj

		game.playSfx("audio/sfx/woosh2.wav")
		action = objB:movePosition( -game.windowSizeX(), -game.windowSizeY(), 0.6, lua_sys.Back_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		game.playSfx("audio/sfx/collect_powerup.wav")
		-- apply bonus to score if not in Atlanta Challenge
		game.applyBonus(i)
	end
end

action = obj:wait(1.0)
action:start()
ActionHelper.waitForAction(action)

game.playSfx("audio/sfx/woosh2.wav")
action = obj:movePosition( -game.windowSizeX()*0.5, 0, 0.25, lua_sys.Quadratic_EASEIN )
action:start()
ActionHelper.waitForAction(action)

game.gameReceiver():Send(game.MsgContinueGame())


