local Button = include("Button")

LeaderboardItem = {}

LeaderboardItem.new = function(name, score, fbid, position, layer, priority, parent, xPos, yPos)

	local item = {}
	
	local obj = game.GetGameWorld():createGameObject("GameObject");
	obj:setTag("LeaderboardItem")
	item.gameobject = obj
	
	local bg = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_small")
	bg:SetLayerByName("HUD")
	bg:center()
	bg:SetPriority(priority)
	
	local font = "zombie_font_description"
	local textGfx = obj:addTextRaster(font, position, -160, 0, 0.8, 0.8)
	textGfx:SetLayerByName(layer)
	textGfx:left_center()
	textGfx:SetPriority(priority-1)
	item.position = textGfx
	
	textGfx = obj:addTextRaster(font, name, -50, 0, 0.5, 0.5)
	textGfx:SetLayerByName(layer)
	textGfx:center()
	textGfx:SetPriority(priority-1)
	item.name = textGfx
	
	textGfx = obj:addTextRaster(font, score.." m", 50, 0, 0.5, 0.5)
	textGfx:SetLayerByName(layer)
	textGfx:right_center()
	textGfx:SetPriority(priority-1)
	item.score = textGfx
	
	item.fbid = fbid
	item.layer = layer or "HUD"
	item.priority = priority or 50
	
	
	if parent then
		obj:setParent(parent)
	end
	
	local x = xPos or 0
	local y = yPos or 0
	obj:setPos(x, y)
	
	local spr = obj:addSprite( game.getFBProfilePic(item.fbid), -115, -3 )
	spr:SetLayerByName(item.layer)
	spr:SetPriority(item.priority-2)
	spr:center()
	
	item.height = spr:height()
	
	--button to send a gift to this friend
	print ("y: ", obj:y() )
	local giftButton = Button.new("xml_resources/sprite_menu.xml", "btn_blue", "HUD", priority-2, obj, 120, 0)
	giftButton.gameobject:setTag("GiftButton")
	giftButton:setText("Send Gift")
	giftButton.onTouchUp = function() 
		print ("send gift to"..item.fbid)
		game.sendGiftRequest(item.fbid)
	end

	item.giftButton = giftButton
		
	return item

end

return LeaderboardItem


