local ActionHelper = include("ActionHelper")
local Button = include("Button")

local MainMenu = {}

local staticObjLayer
local obj
local backgroundLayer
local playerAnimObj

local row1Obj
local row2Obj
local row3Obj
local playBtnObj
local logoObj

local menuScale = game.menuScale()

MainMenu.show = function()
	local basePriority = 50
	
	local buttons = {}
	
	obj = game.GetGameWorld():createGameObject("GameObject")
	obj:setTag("MainMenu")

	staticObjLayer = game.GetGameWorld():createGameObject("GameObject")
	staticObjLayer:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	staticObjLayer:setTag("StaticObj")
	
	playerAnimObj = game.GetGameWorld():createGameObject("PlayerAnimObject")
	playerAnimObj:setParent(staticObjLayer)

	local bg = staticObjLayer:addSpriteSheet("xml_resources/sprite_main.xml", "background", 0, 0, menuScale, menuScale)
	bg:SetLayerByName("BG")
	bg:SetPriority(basePriority)
	bg:center()
	
	--[[local bg_scale = (lua_sys.screenHeight()-bg:height()) / lua_sys.screenHeight()
	bg_scale = bg_scale * game.menuScaleY()
	print(bg_scale)--]]
	--staticObjLayer:setScale(1-bg_scale,1-bg_scale)
	
	row2Obj = game.GetGameWorld():createGameObject("GameObject")
	row2Obj:setParent(staticObjLayer)
	row2Obj:setPos( -lua_sys.screenWidth()*0.5, 0)
	buttons["row2Obj"] = {}
	buttons["row2Obj"].obj = row2Obj
	
	local settings_btn = Button.new("xml_resources/sprite_main.xml", "settings", "HUD", basePriority-10, row2Obj, lua_sys.screenWidth()-50, -lua_sys.screenHeight()/2+40)
	settings_btn.onTouchUp = function()
		MainMenu.hide()
		game.loadMenu("options")
	end
	
	local moreGamesBtn = Button.new("xml_resources/sprite_main.xml", "btn_moregames", "HUD", basePriority-10, row2Obj, 70, lua_sys.screenHeight()/2-40)
	moreGamesBtn.onTouchUp = function()
		game.showMoreGames()
	end
	
	logoObj = game.GetGameWorld():createGameObject("GameObject")
	logoObj:setParent(staticObjLayer)
	logoObj:setPos( 0, -145*menuScale)
	buttons["logoObj"] = {}
	buttons["logoObj"].obj = logoObj
	
	local logo = logoObj:addSpriteSheet("xml_resources/sprite_main.xml", "logo", 0*menuScale, 28*menuScale, menuScale, menuScale)
	logo:SetLayerByName("HUD")
	logo:SetPriority(basePriority-1)
	logo:center()
	
	local logo = logoObj:addSpriteSheet("xml_resources/sprite_main.xml", "logo_pro", 55*menuScale, 50*menuScale, menuScale, menuScale)
	logo:SetLayerByName("HUD")
	logo:SetPriority(basePriority-2)
	logo:center()
	
	playBtnObj = game.GetGameWorld():createGameObject("GameObject")
	playBtnObj:setParent(staticObjLayer)
	playBtnObj:setPos(0, lua_sys.screenHeight()/2 - 50*menuScale)
	buttons["playBtnObj"] = {}
	buttons["playBtnObj"].obj = playBtnObj
	
	local play_btn = Button.new("xml_resources/sprite_main.xml", "play", "HUD", basePriority-6, playBtnObj, lua_sys.screenWidth()/2 - 50*menuScale, 0, true, menuScale)
	play_btn.onTouchUp = function()
		--[[if (game.getSelectedCharacter() == -1) then
			MainMenu.hide()
			game.loadMenu("choose_character")
		else
			MainMenu.hide()
			game.loadMenu("venue_select")
		end--]]
		MainMenu.hide()
		game.loadMenu("venue_select")
	end
	
	--[[twitBtnObj = game.GetGameWorld():createGameObject("GameObject")
	twitBtnObj:setParent(staticObjLayer)
	twitBtnObj:setPos(0, lua_sys.screenHeight()/2 - 50*menuScale)
	buttons["twitBtnObj"] = {}
	buttons["twitBtnObj"].obj = twitBtnObj
	local twit_btn = Button.new("xml_resources/sprite_main.xml", "play", "HUD", basePriority-6, twitBtnObj, 0, 0, true, menuScale/2.0)
	twit_btn.onTouchUp = function()
		game.sendTweet()
	end]]
	
	row3Obj = game.GetGameWorld():createGameObject("GameObject")
	row3Obj:setParent(staticObjLayer)
	row3Obj:setPos( -lua_sys.screenWidth()*0.5, 0)
	buttons["row3Obj"] = {}
	buttons["row3Obj"].obj = row3Obj
	
	local minigame_btn = Button.new("xml_resources/sprite_main.xml", "btn_training", "HUD", basePriority-2, row3Obj, lua_sys.screenWidth()*0.5-140, 0, true, menuScale)
	minigame_btn.onTouchUp = function()
		MainMenu.hide()
		game.loadMenu("minigame_select")
		--game.showMinigameMenu()
	end
	
	local store_btn = Button.new("xml_resources/sprite_main.xml", "btn_store", "HUD", basePriority-2, row3Obj, lua_sys.screenWidth()*0.5+120, 0, true, menuScale)
	store_btn.onTouchUp = function()
		MainMenu.hide()
		game.loadMenu("shop_menu")
	end
	
	playerAnimObj = game.CastToPlayerAnim(playerAnimObj)
	playerAnimObj:remapPlayerAnim()
	playerAnimObj:setScale(0.9*menuScale, 0.9*menuScale)
	playerAnimObj:setPos(0*menuScale, 10*menuScale)
	
	o = buttons["row2Obj"]
	o.y = o.obj:y()
	o.x = o.obj:x()
	o.startX = o.obj:x()-0
	o.startY = o.obj:y()+150
	o.obj:setPos(o.startX, o.startY)
	
	o = buttons["row3Obj"]
	o.y = o.obj:y()
	o.x = o.obj:x()
	o.startX = o.obj:x()-0
	o.startY = o.obj:y()+300
	o.obj:setPos(o.startX, o.startY)
	
	o = buttons["playBtnObj"]
	o.y = o.obj:y()
	o.x = o.obj:x()
	o.startX = o.obj:x()
	o.startY = o.obj:y()+100
	o.obj:setPos(o.startX, o.startY)
	
	o = buttons["logoObj"]
	o.y = o.obj:y()
	o.x = o.obj:x()
	o.startX = o.obj:x()-0
	o.startY = o.obj:y()-500
	o.obj:setScale(0, 0)
	
	
	local action = obj:wait(.4)
	action:start()
	ActionHelper.waitForAction(action)
	
	local obj = buttons["row2Obj"].obj
	local action = row2Obj:movePosition( buttons["row2Obj"].x - obj:x(), buttons["row2Obj"].y - obj:y(), 0.6, lua_sys.Back_EASEOUT )
	action:start()
	
	local wait = obj:wait(.3)
	wait:start()
	ActionHelper.waitForAction(wait)
	--ActionHelper.waitForAction(action)
	
	local obj = buttons["row3Obj"].obj
	local action = row3Obj:movePosition( buttons["row3Obj"].x - obj:x(), buttons["row3Obj"].y - obj:y(), 0.6, lua_sys.Back_EASEOUT )
	action:start()
	
	local wait = obj:wait(.3)
	wait:start()
	ActionHelper.waitForAction(wait)
	--ActionHelper.waitForAction(action)
	
	local obj = buttons["playBtnObj"].obj
	local action = playBtnObj:movePosition( buttons["playBtnObj"].x - obj:x(), buttons["playBtnObj"].y - obj:y(), 0.4, lua_sys.Back_EASEOUT  )
	action:start()
	--ActionHelper.waitForAction(action)
	
	local obj = buttons["logoObj"].obj
	
	local action = obj:moveScale( 1, 1, 0.5, lua_sys.Back_EASEOUT  )
	action:start()
	ActionHelper.waitForAction(action)

end

MainMenu.hide = function()
	local obj = game.GetGameWorld():getObjectByTag("MainMenu")
	
	
	if obj then
				
		local staticObjLayer = game.GetGameWorld():getObjectByTag("StaticObj")
		if staticObjLayer  then
			print"destroy Static Layer"
			game.GetGameWorld():destroyGameObject(staticObjLayer)
		end
		
		game.GetGameWorld():destroyGameObject(obj)
		
	else
		print("Where'd options go?")
	end
end

MainMenu.show()