local MenuTab = {}

MenuTab.new = function(layer, priority, parent, xPos, yPos)

	local sheet = "xml_resources/sprite_menu.xml"

	local button = {}
	
	function button:setText(text, font)
	
		if self.text then
			self.gameobject:removeGfx(self.text)
		end

		local font = font or "zombie_font_description"
		local textGfx = self.gameobject:addTextRaster(font, text, -12, 24, 0.45, 0.45, game.GfxText_Format_Center)
		textGfx:SetLayerByName(self.layer)
		textGfx:setHAnchor(game.Gfx_HA_ALIGN_RIGHT)
		textGfx:setVAnchor(game.Gfx_VA_ALIGN_BOTTOM)
		textGfx:SetPriority(self.priority-1)
		self.text = textGfx
		
	end
	
	button.layer = layer or "HUD"
	button.priority = priority or 50
	
	local obj = game.GetGameWorld():createGameObject("GameObject");
	button.gameobject = obj
	if parent then
		obj:setParent(parent)
	end
	
	local x = xPos or 0
	local y = yPos or 0
	obj:setPos(x, y)
	
	local spr = obj:addSpriteSheet( sheet, "tab_blue", 0, 0 )
	spr:SetLayerByName(button.layer)
	spr:SetPriority(button.priority)
	spr:setHAnchor(game.Gfx_HA_ALIGN_RIGHT)
	spr:setVAnchor(game.Gfx_VA_ALIGN_CENTER)
	
	button.onSprite = spr
	
	spr = obj:addSpriteSheet( sheet, "tab_blue_down", 0, 0 )
	spr:SetLayerByName(button.layer)
	spr:SetPriority(button.priority)
	spr:setHAnchor(game.Gfx_HA_ALIGN_RIGHT)
	spr:setVAnchor(game.Gfx_VA_ALIGN_CENTER)
	
	button.offSprite = spr
	
	button.touch = obj:addTouch( button.onSprite:width(), button.onSprite:height(), priority )
	button.touch:setAnchor( button.onSprite:width(), button.onSprite:height() * 0.5 )
	
	button.state = 0
	button.onSprite:SetVisible(false)
	button.offSprite:SetVisible(true)
	
	function button:toggle()
		self.on = not self.on
		self.onSprite:SetVisible(self.on)
		self.offSprite:SetVisible(not self.on)
		if self.onToggle then
			self:onToggle()
		end
	end
	
	return button

end

return MenuTab