local ActionHelper = include("ActionHelper")
local Button = include("Button")
local StatBar = include("StatBar")

local menuScale = game.menuScale()

local MinigamePauseMenu = {}

local obj, bgObj
local totalCoinObj
local buttonObj

local action, action2, action3

local lastButton = nil

MinigamePauseMenu.show = function()
	local basePriority = 50
	
	obj = game.GetGameWorld():createGameObject("GameObject")
	obj:setTag("MinigamePauseMenu")
	
	bgObj = game.GetGameWorld():createGameObject("GameObject")
	bgObj:setTag("bgObj")
	bgObj:setParent(obj)
	
	buttonObj = game.GetGameWorld():createGameObject("GameObject")
	buttonObj:setTag("buttonObj")
	buttonObj:setParent(obj)
	
	totalCoinObj = game.GetGameWorld():createGameObject("GameObject")
	totalCoinObj:setTag("totalCoinObj")
	totalCoinObj:setParent(obj)
	
	--Create buttons
	
	local spacing = 55*menuScale
	local startY = -58*menuScale
	
	--Resume
	local buttonResume = Button.new("xml_resources/sprite_menu.xml", "tab_blue", "POPUP", basePriority-2, buttonObj, 0, startY + spacing * 0)
	buttonResume.gameobject:setTag("buttonAccept")
	buttonResume:setText( game.getLocalizedText("RESUME"), nil, 0.4, 0, 15*menuScale  )
	buttonResume:addOverlaySprite( "xml_resources/sprite_menu.xml", "btn_play", 1.0, 1*menuScale, -10*menuScale  )
	buttonResume.onTouchUp = function()
		MinigamePauseMenu.hide()
		game.resumeGame()
	end
	

	--Venue Menu
	local buttonMainMenu = Button.new("xml_resources/sprite_menu.xml", "tab_blue", "POPUP", basePriority-2, buttonObj, 0, startY + spacing * 1)
	buttonMainMenu.gameobject:setTag("buttonAccept")
	buttonMainMenu:setText( game.getLocalizedText("TRAINING"), nil, 0.4, 0, 15*menuScale  )
	buttonMainMenu:addOverlaySprite( "xml_resources/sprite_menu.xml", "btn_home_small", 1, 1*menuScale, -10*menuScale  )
	buttonMainMenu.onTouchUp = function()
		game.showQuitGamePrompt("minigame_select")
	end
	
	local fadedBGObj = game.GetGameWorld():createGameObject("GameObject");
	fadedBGObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	fadedBGObj:setTag("FadedBG")
	
	local fadedBG = fadedBGObj:addSprite("gfx/menu/bg/background")
	fadedBGObj:setScale( lua_sys.screenWidth()/fadedBG:width(), lua_sys.screenHeight()/fadedBG:width() )
	fadedBG:SetLayerByName("POPUP")
	fadedBG:center()
	fadedBG:SetPriority(basePriority)
	fadedBG:SetAlpha(200)
	
	local touch = bgObj:addTouch( lua_sys.screenWidth(), lua_sys.screenHeight(), basePriority )
	touch:setAnchor( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	touch:setEnabled(0)
	
	
	buttonObj:setPos( game.windowSizeX(), game.windowSizeY()*0.5)

	-- bg
	local bgGfx = bgObj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_large", 0, 0, menuScale, menuScale)
	bgGfx:SetLayerByName("POPUP")
	bgGfx:SetPriority(basePriority-1)
	bgGfx:center()
	
	bgObj:setPos( game.windowSizeX()*0.4, -bgGfx:height()*menuScale )
	
	
	--Player
	--[[local playerAnimObj = game.GetGameWorld():createGameObject("PlayerAnimObject")
	playerAnimObj:setParent(bgObj)
	
	playerAnimObj = game.CastToPlayerAnim(playerAnimObj)
	playerAnimObj:remapPlayerAnim()
	playerAnimObj:setScale(0.6*menuScale, 0.6*menuScale)
	playerAnimObj:setPos(bgObj:x() - 95*menuScale, 0)
	
	playerAnimObj:getAnim():SetLayerByName("POPUP")
	playerAnimObj:getAnim():SetPriority(basePriority-3)
	playerAnimObj:getAnim():center()]]
	
	--Stats
	local xpos = 0*menuScale
	local ypos = -45*menuScale
	local spacing = 25*menuScale
	local bar1 = StatBar.new(game.getContactStatInfo(), false, "POPUP", basePriority-3, bgObj, xpos, ypos+spacing*1)
	local bar2 = StatBar.new(game.getVisionStatInfo(), false, "POPUP", basePriority-3, bgObj, xpos, ypos+spacing*2)
	local bar3 = StatBar.new(game.getPowerStatInfo(), false, "POPUP", basePriority-3, bgObj, xpos, ypos+spacing*3)
		
	-- results text
	local text = game.getLocalizedText("PAUSE")
	local titleGfx = bgObj:addTextRaster( game.getMidSizeFont(), text, 0, -bgGfx:height()*menuScale*0.5+10*menuScale, 1*menuScale, 1*menuScale, game.GfxText_Format_Center )
	titleGfx:SetLayerByName("POPUP")
	titleGfx:SetPriority(basePriority-2)
	titleGfx:center()
		
		
	-- bring the bg down
	game.playSfx("audio/sfx/woosh2.wav")
	action = bgObj:movePosition( 0, game.windowSizeY()*0.5+bgGfx:height()*menuScale, 0.5, lua_sys.Back_EASEOUT )
	-- bring the total coin obj in from left
	--game.playSfx("audio/sfx/woosh2.wav")
	--action2 = totalCoinObj:movePosition( game.windowSizeX()*0.5+30, 0, 0.5, lua_sys.Back_EASEOUT )
	-- bring buttons in from right
	game.playSfx("audio/sfx/woosh2.wav")
	action3 = buttonObj:movePosition( -50*menuScale, 0, 0.5, lua_sys.Quadratic_EASEOUT )
	
	action:start()
	--action2:start()
	action3:start()
	ActionHelper.waitForAction(action)
	--ActionHelper.waitForAction(action2)
	ActionHelper.waitForAction(action3)
			
	touch:setEnabled(1)
end

MinigamePauseMenu.hide = function()
	local obj = game.GetGameWorld():getObjectByTag("MinigamePauseMenu")
	local FadedBGObj = game.GetGameWorld():getObjectByTag("FadedBG")
	
	if obj then
		game.playSfx("audio/sfx/woosh1.wav")
		action = obj:movePosition( lua_sys.screenWidth() - obj:x(), 0, 0.5, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		
		game.GetGameWorld():destroyGameObject(FadedBGObj)
		game.GetGameWorld():destroyGameObject(obj)		
	
	else
		print("Where'd options go?")
	end
	
	game.killStoreRoutine()
	
end

MinigamePauseMenu.show()
