local ActionHelper = include("ActionHelper")
local Button = include("Button")
local StatBar = include("StatBar")

local MinigameSelect = {}

local staticObjLayer
local obj

MinigameSelect.updateStats = function()
	local contact = game.playerTotalContact()
	local vision = game.playerTotalVision()
	local power = game.playerTotalPower()
	local statString = "Contact: " .. contact .. "\nVision: " .. vision .. "\nPower: " .. power
	statText:changeText(statString)
end

MinigameSelect.show = function()
	local basePriority = 50
	
	local buttons = {}
	
	obj = game.GetGameWorld():createGameObject("GameObject")
	obj:setTag("MinigameSelect")

	staticObjLayer = game.GetGameWorld():createGameObject("GameObject")
	staticObjLayer:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	
	local bg = staticObjLayer:addSpriteSheet("xml_resources/minigame_select_menu.xml", "background", 0, 0, game.menuScale(), game.menuScale())
	bg:SetLayerByName("BG")
	bg:SetPriority(basePriority)
	bg:center()
	
	local homeBtn = Button.new("xml_resources/sprite_menu.xml", "btn_home_small", "HUD", basePriority-2, obj, 20*game.menuScale(), 20*game.menuScale(), true, game.menuScale())
	homeBtn.onTouchUp = function()
		MinigameSelect.hide()
		game.loadMenu("main_menu")
	end
	
	local minigameData = game.getMinigameInfo(2)
	
	local bullpenBtn
	if( not minigameData.unlocked_ ) then
		bullpenBtn = Button.new("xml_resources/minigame_select_menu.xml", "btn_bullpen_lock", "HUD", basePriority-2, obj, lua_sys.screenWidth()/2+110*game.menuScale(), lua_sys.screenHeight()/2+65*game.menuScale(), false, game.menuScale())
	else
		bullpenBtn = Button.new("xml_resources/minigame_select_menu.xml", "btn_bullpen", "HUD", basePriority-2, obj, lua_sys.screenWidth()/2+110*game.menuScale(), lua_sys.screenHeight()/2+65*game.menuScale(), true, game.menuScale())
	end
	bullpenBtn.onTouchUp = function()
		game.showMinigamePopup(2)
	end
	
	minigameData = game.getMinigameInfo(1)
	local juggleBtn
	if( not minigameData.unlocked_ ) then
		juggleBtn = Button.new("xml_resources/minigame_select_menu.xml", "btn_juggle_lock", "HUD", basePriority-2, obj, lua_sys.screenWidth()/2+125*game.menuScale(), lua_sys.screenHeight()/2-85*game.menuScale(), false, game.menuScale())
	else
		juggleBtn = Button.new("xml_resources/minigame_select_menu.xml", "btn_juggle", "HUD", basePriority-2, obj, lua_sys.screenWidth()/2+125*game.menuScale(), lua_sys.screenHeight()/2-85*game.menuScale(), true, game.menuScale())
	end
	juggleBtn.onTouchUp = function()
		game.showMinigamePopup(1)
	end
	
	minigameData = game.getMinigameInfo(3)
	local battingBtn
	if( not minigameData.unlocked_ ) then
		battingBtn = Button.new("xml_resources/minigame_select_menu.xml", "btn_batting_lock", "HUD", basePriority-1, obj, lua_sys.screenWidth()/2-70*game.menuScale(), lua_sys.screenHeight()/2-90*game.menuScale(), false, game.menuScale())
	else
		battingBtn = Button.new("xml_resources/minigame_select_menu.xml", "btn_batting", "HUD", basePriority-1, obj, lua_sys.screenWidth()/2-70*game.menuScale(), lua_sys.screenHeight()/2-90*game.menuScale(), true, game.menuScale())
	end
	battingBtn.onTouchUp = function()
		game.showMinigamePopup(3)
	end
	
	local xpos = -lua_sys.screenWidth() * 0.5 + 70
	local ypos =  lua_sys.screenHeight() * 0.5 - 100
	local spacing = 25
	local bar1 = StatBar.new(game.getContactStatInfo(), false, "MAP", basePriority, staticObjLayer, xpos, ypos+spacing*1)
	local bar2 = StatBar.new(game.getVisionStatInfo(), false, "MAP", basePriority, staticObjLayer, xpos, ypos+spacing*2)
	local bar3 = StatBar.new(game.getPowerStatInfo(), false, "MAP", basePriority, staticObjLayer, xpos, ypos+spacing*3)
	
	--[[local fatigueBar = ProgressBar.new("gfx/menu/common/stat_empty", "gfx/menu/common/stat_fatigue", "MAP", basePriority, staticObjLayer, lua_sys.screenWidth() * 0.5-50, lua_sys.screenHeight() * 0.5-50)
	fatigueBar:setPercent(1-game.getPlayerFatigue(), 0)
	fatigueBar:setText("Fatigue: " .. math.floor((1-game.getPlayerFatigue())*100).."%")--]]
	game.sendPlayerFatigue()
end

MinigameSelect.hide = function()
	local obj = game.GetGameWorld():getObjectByTag("MinigameSelect")
	
	if obj then
		game.GetGameWorld():destroyGameObject(obj)
		
		if staticObjLayer  then
			game.GetGameWorld():destroyGameObject(staticObjLayer)
		end
		
	else
		print("Where'd options go?")
	end
	
	game.loadMenu("main_menu")
end

MinigameSelect.show()