local obj, mission = ...

local ActionHelper = include("ActionHelper")

print( "Description:", mission:getDescription() )

local menuScale = game.menuScale()
local px = game.windowSizeX() * 0.5
local py = -64*menuScale
local basePriority = 130

--local obj = game.GetGameWorld():createGameObject("GameObject");
obj:setTag("NotificationMessage")
obj:setPos( px, py )

local rewardObj = game.GetGameWorld():createGameObject("GameObject");
rewardObj:setParent(obj)
--rewardObj:SetPriority(basePriority-5)
--rewardObj:SetLayerByName("HUD")

local text = game.getLocalizedText(mission:getDescription())
text = select( 1, text:gsub("XXX", mission:getTargetOccurrences()) )
text = select( 1, text:gsub("YYY", mission:getEndTarget()) )

local textGfx
local tempObj = game.GetGameWorld():createGameObject("GameObject")
local tempGfx = tempObj:addTextRaster(game.getDescriptionFont(), text, -30*menuScale, 0, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Left, 180*menuScale, true )
--[[if(text:len()<25) then
	textGfx = obj:addTextRaster(game.getDescriptionFont(), text, -30, 0, 0.5, 0.5, game.GfxText_Format_Left, 180, true )
else	
	textGfx = obj:addTextRaster(game.getDescriptionFont(), text, -30, -10, 0.5, 0.5, game.GfxText_Format_Left, 180, true )
end]]

if(tempGfx:numLines() == 1) then
	textGfx = obj:addTextRaster(game.getDescriptionFont(), text, -30*menuScale, 0, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Left, 180*menuScale, true )
elseif(tempGfx:numLines() == 2) then
	textGfx = obj:addTextRaster(game.getDescriptionFont(), text, -30*menuScale, -8*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Left, 180*menuScale, true )
else
	textGfx = obj:addTextRaster(game.getDescriptionFont(), text, -30*menuScale, -14*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Left, 180*menuScale, true )
end

textGfx:SetLayerByName("HUD")
textGfx:SetPriority(basePriority-5)
textGfx:center()

local gfx2
if( mission:isMainObjective() == true ) then
	gfx2 = obj:addSpriteSheet( "xml_resources/sprite_menu.xml", "box_small_important", 0, 0, menuScale, menuScale )
else
	gfx2 = obj:addSpriteSheet( "xml_resources/sprite_menu.xml", "box_small", 0, 0, menuScale, menuScale )
end
gfx2:SetLayerByName("HUD")
gfx2:SetPriority(basePriority)
gfx2:center()

local objRewardVal = rewardObj:addTextRaster(game.getDescriptionFont(), mission:getRewardValue(), -30*menuScale, 2*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Right, 335*menuScale, true )
objRewardVal:SetLayerByName("HUD")
objRewardVal:center()
objRewardVal:SetPriority(basePriority-5)



local rewardSpr
if( mission:getRewardType() == 0 ) then
	rewardSpr = rewardObj:addSpriteSheet("xml_resources/sprite_menu.xml", "coin_gold", 153*menuScale, 0, 0.7*menuScale, 0.7*menuScale)
else
	rewardSpr = rewardObj:addSpriteSheet("xml_resources/sprite_menu.xml", "coin_platinum", 153*menuScale, 0, 0.7*menuScale, 0.7*menuScale)
end

rewardSpr:SetLayerByName("HUD")
rewardSpr:center()
rewardSpr:SetPriority(basePriority-5)

local action = obj:movePosition( 0, 100*menuScale, 0.5, lua_sys.Back_EASEOUT )
action:start()
ActionHelper.waitForAction(action)

action = obj:wait(1.0)
action:start()
ActionHelper.waitForAction(action)

if( mission:getRewardType() == 0 ) then
	action = rewardObj:movePosition( -350*menuScale, 50*menuScale, 0.5, lua_sys.Back_EASEOUT )
else
	action = rewardObj:movePosition( -350*menuScale, 80*menuScale, 0.5, lua_sys.Back_EASEOUT )
end

action:start()
ActionHelper.waitForAction(action)

game.playSfx("audio/sfx/cash_register.wav")
if( mission:getRewardType() == 0 ) then
	game.updateGoldRewardCoins( mission:getRewardValue() )
else
	game.updatePlatinumRewardCoins( mission:getRewardValue() )
end
game.GetGameWorld():destroyGameObject(rewardObj)

action = obj:wait(0.5)
action:start()
ActionHelper.waitForAction(action)

action = obj:movePosition( 0, -100*menuScale, 0.5, lua_sys.Back_EASEIN )
action:start()
ActionHelper.waitForAction(action)

game.GetGameWorld():destroyGameObject(obj)

	




