--local mission = ...
local obj, isMainObjective = ...

local ActionHelper = include("ActionHelper")

local menuScale = game.menuScale()
local px = game.windowSizeX() * 0.5
local py = -64*menuScale
local basePriority = 125

--local obj = game.GetGameWorld():createGameObject("GameObject");
obj:setTag("NotificationMessage")
obj:setPos( px, py )

local rewardObj = game.GetGameWorld():createGameObject("GameObject");
rewardObj:setParent(obj)

local missionControl = game.getMissionControl()	

local text = ""
if (isMainObjective == 1) then
	text = game.getLocalizedText("MAIN_OBJECTIVES_PROGRESS")
	local numComplete = missionControl:totalMissionsCompleted(game.getLevelId(), true)
	local numTarget = 5
	
	if (numComplete == numTarget) then
		text = game.getLocalizedText("MAIN_OBJECTIVES_COMPLETE")
	end
	
	text = select( 1, text:gsub("XXX", numComplete) )
	text = select( 1, text:gsub("YYY", numTarget) )
else
	text = game.getLocalizedText("BONUS_OBJECTIVES_PROGRESS")
	local numComplete = missionControl:totalMissionsCompleted(game.getLevelId())
	local numTarget = 10
	
	if (numComplete == numTarget) then
		text = game.getLocalizedText("BONUS_OBJECTIVES_COMPLETE")
	end
	
	text = select( 1, text:gsub("XXX", numComplete) )
	text = select( 1, text:gsub("YYY", numTarget) )
end

local textGfx
local tempObj = game.GetGameWorld():createGameObject("GameObject")
local scale = 0.6*menuScale
local tempGfx = tempObj:addTextRaster(game.getDescriptionFont(), text, 0, 0, scale, scale, game.GfxText_Format_Center, 300*menuScale, true )

if(tempGfx:numLines() == 1) then
	textGfx = obj:addTextRaster(game.getDescriptionFont(), text, 0, 0, scale, scale, game.GfxText_Format_Center, 300*menuScale, true )
elseif(tempGfx:numLines() == 2) then
	textGfx = obj:addTextRaster(game.getDescriptionFont(), text, 0, -8*menuScale, scale, scale, game.GfxText_Format_Center, 300*menuScale, true )
else
	textGfx = obj:addTextRaster(game.getDescriptionFont(), text, 0, -14*menuScale, scale, scale, game.GfxText_Format_Center, 300*menuScale, true )
end

textGfx:SetLayerByName("HUD")
textGfx:SetPriority(basePriority-5)
textGfx:center()

local gfx2
if( isMainObjective == 1 ) then
	gfx2 = obj:addSpriteSheet( "xml_resources/sprite_menu.xml", "box_small_important", 0 ,0, menuScale, menuScale )
else
	gfx2 = obj:addSpriteSheet( "xml_resources/sprite_menu.xml", "box_small", 0 ,0, menuScale, menuScale )
end
gfx2:SetLayerByName("HUD")
gfx2:SetPriority(basePriority)
gfx2:center()

local action = obj:movePosition( 0, 100*menuScale, 0.5, lua_sys.Back_EASEOUT )
action:start()
ActionHelper.waitForAction(action)

action = obj:wait(1.0)
action:start()
ActionHelper.waitForAction(action)

action = obj:movePosition( 0, -100*menuScale, 0.5, lua_sys.Back_EASEIN )
action:start()
ActionHelper.waitForAction(action)

game.GetGameWorld():destroyGameObject(obj)