local inStore = ...

local ActionHelper = include("ActionHelper")
local Button = include("Button")
--local BuyPremiumPopup = include("BuyPremiumPopup")

local menuScale = game.menuScale()
local NoMoneyPrompt = {}
NoMoneyPrompt.resume = false --whether to resume game when menu is closed

local obj = game.GetGameWorld():createGameObject("GameObject");
obj:setTag("NoMoneyPrompt")
obj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
obj:setScale(0.0, 1.0)

local fadedBGObj = game.GetGameWorld():createGameObject("GameObject");
fadedBGObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
fadedBGObj:setTag("FadedBG_nomoney")

local textObj = game.GetGameWorld():createGameObject("GameObject");
textObj:setTag("NoMoneyPromptText")
textObj:setParent(obj)

	
-- create the menu
NoMoneyPrompt.show = function()

	local basePriority = 30
	
	local fadedBG = fadedBGObj:addSprite("gfx/menu/bg/background")
	fadedBGObj:setScale( lua_sys.screenWidth()/fadedBG:width(), lua_sys.screenHeight()/fadedBG:width() )
	fadedBG:SetLayerByName("POPUP")
	fadedBG:center()
	fadedBG:SetPriority(basePriority)
	fadedBG:SetAlpha(200)
	
	local bg = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_medium", 0, 0, menuScale, menuScale)
	bg:SetLayerByName("POPUP")
	bg:center()
	bg:SetPriority(basePriority-1)

	local closeButton = Button.new("xml_resources/sprite_menu.xml", "btn_close", "POPUP", basePriority-2, obj, -175*menuScale, -bg:height()*menuScale * 0.5 + 10*menuScale)
	closeButton.onTouchUp = function() 
		NoMoneyPrompt.hide()
	end

	local touch = obj:addTouch( lua_sys.screenWidth(), lua_sys.screenHeight(), basePriority )
	touch:setAnchor( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	touch:setEnabled(1)

	-- Message
	local textGfx = textObj:addTextRaster("zombie_font_description", game.getLocalizedText("NOT_ENOUGH_MONEY"), 0, -35*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Center, 355*menuScale, true )
	textGfx:SetLayerByName("POPUP")
	textGfx:center()
	textGfx:SetPriority(basePriority-2)

	-- yes/no buttons
	local buttonYes = Button.new("xml_resources/sprite_menu.xml", "btn_green", "POPUP", basePriority-2, obj, -60*menuScale, 25*menuScale, true, menuScale)
	buttonYes.gameobject:setTag("buttonYes")
	buttonYes:setText( game.getLocalizedText("MAIN_YES") )
	buttonYes.onTouchUp = function()
		NoMoneyPrompt.hide(false)
		game.showBuyPremiumPopup(inStore)
	end
	
	local buttonNo = Button.new("xml_resources/sprite_menu.xml", "btn_red", "POPUP", basePriority-2, obj, 60*menuScale, 25*menuScale, true, menuScale)
	buttonNo.gameobject:setTag("buttonNo")
	buttonNo:setText( game.getLocalizedText("MAIN_NO") )
	buttonNo.onTouchUp = function()
		NoMoneyPrompt.hide()
	end
	
	--actions
	textObj:setAlpha(0.0)
	
	local action = obj:moveScale( 1.0, 0, 0.45, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
	
	action = textObj:moveAlpha( 1.0, 0.15, lua_sys.Quadratic_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
	
end

-- close the menu
NoMoneyPrompt.hide = function( animate )

	if animate == nil then
		animate = true
	end
	
	local obj = game.GetGameWorld():getObjectByTag("NoMoneyPrompt")
	local textObj = game.GetGameWorld():getObjectByTag("NoMoneyPromptText")
	local FadedBGObj = game.GetGameWorld():getObjectByTag("FadedBG_nomoney")
	if obj then
		
		if( animate == true ) then
			action = obj:moveScale( -1.0, 0, 0.25, lua_sys.Quadratic_EASEIN )
			action:start()
			ActionHelper.waitForAction(action)
		end
		
		game.GetGameWorld():destroyGameObject(textObj)
		game.GetGameWorld():destroyGameObject(FadedBGObj)
		game.GetGameWorld():destroyGameObject(obj)
	end
	
	if( NoMoneyPrompt.resume == true) then
		game.resumeGame()
	end
end

NoMoneyPrompt.show()
