local nameText, descText, rewardType, rewardValue, progressText = ...

local ActionHelper = include("ActionHelper")
local Button = include("Button")

local ObjectiveItemInfo = {}

ObjectiveItemInfo.show = function()

	local obj = game.GetGameWorld():createGameObject("GameObject");
	obj:setTag("ObjectiveItemInfo")

	local basePriority = 40

	local fadedBGObj = game.GetGameWorld():createGameObject("GameObject");
	fadedBGObj:setParent(rootObj)
	fadedBGObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	fadedBGObj:setTag("FadedBG_p")
	
	local fadedBG = fadedBGObj:addSprite("gfx/menu/bg/background")
	fadedBGObj:setScale( lua_sys.screenWidth()/fadedBG:width(), lua_sys.screenHeight()/fadedBG:width() )
	fadedBG:SetLayerByName("POPUP")
	fadedBG:center()
	fadedBG:SetPriority(basePriority)
	fadedBG:SetAlpha(200)
	
	local bg = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_large")
	bg:SetLayerByName("POPUP")
	bg:center()
	
	bg:SetPriority(basePriority-1)

	local closeButton = Button.new("xml_resources/sprite_menu.xml", "btn_close", "POPUP", basePriority-2, obj, -175, -bg:height() * 0.5 + 10)
	closeButton.onTouchUp = function() 
		ObjectiveItemInfo.hide()
	end
	
	local mainButton = Button.zone("POPUP", basePriority-1, obj, 0, 0, lua_sys.screenWidth(), lua_sys.screenHeight())
	mainButton.onTouchUp = function() 
		ObjectiveItemInfo.hide()
	end

	local touch = obj:addTouch( lua_sys.screenWidth(), lua_sys.screenHeight(), basePriority )
	touch:setAnchor( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	touch:setEnabled(1)

	local textObj = game.GetGameWorld():createGameObject("GameObject");
	textObj:setTag("ObjectiveItemInfoText")
	
	local objName = textObj:addTextRaster("zombie_font_description", game.getLocalizedText(nameText), 0, -55, 0.7, 0.7, game.GfxText_Format_Center, 350, true )
	objName:SetLayerByName("POPUP")
	objName:center()
	objName:SetPriority(basePriority-2)
	
	local objDesc = textObj:addTextRaster("zombie_font_description", game.getLocalizedText(descText), -30, 48, 0.5, 0.5, game.GfxText_Format_Left, 260, true )
	objDesc:SetLayerByName("POPUP")
	objDesc:center()
	objDesc:SetPriority(basePriority-2)
	
	local objRewardVal = textObj:addTextRaster("zombie_font_description", rewardValue, -30, 49, 0.5, 0.5, game.GfxText_Format_Right, 335, true )
	objRewardVal:SetLayerByName("POPUP")
	objRewardVal:center()
	objRewardVal:SetPriority(basePriority-2)
	
	local rewardSpr = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "coin_gold", 153, 48, 0.7, 0.7)
	if( rewardType == 0 ) then
		rewardSpr = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "coin_gold", 153, 48, 0.7, 0.7)
	else
		rewardSpr = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "coin_platinum", 153, 48, 0.7, 0.7)
	end
	rewardSpr:SetLayerByName("POPUP")
	rewardSpr:center()
	rewardSpr:SetPriority(basePriority-2)
	
	local objProgress = textObj:addTextRaster("zombie_font_description", progressText, 0, 0, 0.5, 0.5, game.GfxText_Format_Center, 335, true )
	objProgress:SetLayerByName("POPUP")
	objProgress:center()
	objProgress:SetPriority(basePriority-2)
	
	textObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	textObj:setAlpha(0.0)
	
	obj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	obj:setScale(0.0, 1.0)
	
	local action = obj:moveScale( 1.0, 0, 0.45, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)

	action = textObj:moveAlpha( 1.0, 0.15, lua_sys.Quadratic_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
	
	touch:setEnabled(1)
	
end

ObjectiveItemInfo.hide = function()

	local obj = game.GetGameWorld():getObjectByTag("ObjectiveItemInfo")
	local textObj = game.GetGameWorld():getObjectByTag("ObjectiveItemInfoText")
	local FadedBGObj = game.GetGameWorld():getObjectByTag("FadedBG_p")
	if obj then
		local action = textObj:moveAlpha( -1.0, 0.1, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
	
		action = obj:moveScale( -1.0, 0, 0.25, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		
		game.GetGameWorld():destroyGameObject(textObj)
		game.GetGameWorld():destroyGameObject(FadedBGObj)
		game.GetGameWorld():destroyGameObject(obj)
	end

end

ObjectiveItemInfo.show()