local Button = include("Button")

local menuScale = game.menuScale()

Objective = {}

Objective.new = function(name, desc, rewardType, rewardValue, progressText, isComplete, isMainObjective, isFailed, inGame, layer, priority, parent, xPos, yPos)

	local item = {}
	
	local obj = game.GetGameWorld():createGameObject("GameObject");
	obj:setTag("Objective")
	item.gameobject = obj
	
	local bgSpriteName = "box_small"
	if (isMainObjective) then
		bgSpriteName = "box_small_important"
	end
	
	local bg = obj:addSpriteSheet("xml_resources/sprite_menu.xml", bgSpriteName, 0, 0, menuScale, menuScale)
	bg:SetLayerByName("HUD")
	bg:center()
	bg:SetPriority(priority)
	
	item.height = bg:height()
	
	local statusSpr = nil
	if (isComplete) then
		statusSpr = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "objective_check", -bg:width()*0.5*menuScale+3*menuScale, -8*menuScale, menuScale, menuScale)
	else
		statusSpr = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "objective_gray", -bg:width()*0.5*menuScale+3*menuScale, -8*menuScale, menuScale, menuScale)
	end
	statusSpr:SetLayerByName("HUD")
	statusSpr:left_center()
	statusSpr:SetPriority(priority-2)
	
	if (isMainObjective) then
		--[[local mainIcon = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "star", -bg:width()*0.5+0, -bg:height()*0.5+8, 0.5, 0.5)
		mainIcon:SetLayerByName("HUD")
		mainIcon:center()
		mainIcon:SetPriority(priority-1)--]]
	end
	
	local font = "zombie_font_description"
	if (isFailed and not isComplete) then
		font = "zombie_font_description_red"
	end
	local tempObj = game.GetGameWorld():createGameObject("GameObject")
	local tempGfx = tempObj:addTextRaster(font, name, -30*menuScale, 0*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Left, 180*menuScale, true )
	
	if(tempGfx:numLines() == 1) then
		textGfx = obj:addTextRaster(font, name, -30*menuScale, 0*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Left, 180*menuScale, true )
	elseif(tempGfx:numLines() == 2) then
		textGfx = obj:addTextRaster(font, name, -30*menuScale, -8*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Left, 180*menuScale, true )
	else
		textGfx = obj:addTextRaster(font, name, -30*menuScale, -14*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Left, 180*menuScale, true )
	end

	game.GetGameWorld():destroyGameObject(tempObj)
	textGfx:SetLayerByName(layer)
	textGfx:center()
	textGfx:SetPriority(priority-1)
	
	item.name = textGfx
	
	item.layer = layer or "HUD"
	item.priority = priority or 50
	
	
	if parent then
		obj:setParent(parent)
	end
	
	local x = xPos or 0
	local y = yPos or 0
	obj:setPos(x, y)
		
	--button to send a gift to this friend
	--print ("y: ", obj:y() )
	--[[local moreInfoButton = Button.new("xml_resources/sprite_menu.xml", "btn_yellow", "HUD", priority-2, obj, 120, 0)
	moreInfoButton.gameobject:setTag("MoreInfoButton")
	moreInfoButton:setText( game.getLocalizedText("MORE_INFO") )
	moreInfoButton.onTouchUp = function() 
		game.showObjectiveInfo(name, desc, rewardType, rewardValue, progressText)
	end

	item.moreInfoButton = moreInfoButton--]]
	
	local progressTextObj = nil
	
	if ( inGame == 1 ) then
		if (isComplete) then
			progressTextObj = obj:addTextRaster(font, progressText, 125*menuScale, 0*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Center, 80*menuScale, true )
		else
			local iconX = 158*menuScale
			local iconY = -12*menuScale
			
			progressTextObj = obj:addTextRaster(font, progressText, 100*menuScale, 12*menuScale, 0.4*menuScale, 0.4*menuScale, game.GfxText_Format_Right, 120*menuScale, true )
			
			local objRewardVal = obj:addTextRaster("zombie_font_description", rewardValue, iconX-63*menuScale, iconY+1*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Right, 100*menuScale, true )
			objRewardVal:SetLayerByName("HUD")
			objRewardVal:center()
			objRewardVal:SetPriority(priority-2)
			
			local rewardSpr = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "coin_gold", iconX, iconY, 0.7*menuScale, 0.7*menuScale)
			if( rewardType == 0 ) then
				rewardSpr = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "coin_gold", iconX, iconY, 0.7*menuScale, 0.7*menuScale)
			else
				rewardSpr = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "coin_platinum", iconX, iconY, 0.7*menuScale, 0.7*menuScale)
			end
			rewardSpr:SetLayerByName("HUD")
			rewardSpr:center()
			rewardSpr:SetPriority(priority-2)
		end
	else
		if (isComplete) then
			progressTextObj = obj:addTextRaster(font, progressText, 125*menuScale, 0, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Center, 80*menuScale, true )
		else
			local iconX = 158*menuScale
			local iconY = 0
			
			local objRewardVal = obj:addTextRaster("zombie_font_description", rewardValue, iconX-63*menuScale, iconY+1*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Right, 100*menuScale, true )
			objRewardVal:SetLayerByName("HUD")
			objRewardVal:center()
			objRewardVal:SetPriority(priority-2)
			
			local rewardSpr = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "coin_gold", iconX, iconY, 0.7*menuScale, 0.7*menuScale)
			if( rewardType == 0 ) then
				rewardSpr = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "coin_gold", iconX, iconY, 0.7*menuScale, 0.7*menuScale)
			else
				rewardSpr = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "coin_platinum", iconX, iconY, 0.7*menuScale, 0.7*menuScale)
			end
			rewardSpr:SetLayerByName("HUD")
			rewardSpr:center()
			rewardSpr:SetPriority(priority-2)
		end
	end
	
	if (progressTextObj) then
		progressTextObj:SetLayerByName(layer)
		progressTextObj:center()
		progressTextObj:SetPriority(priority-1)
	end

	return item

end

return Objective


