local ActionHelper = include("ActionHelper")
local Button = include("Button")
local ToggleButton = include("ToggleButton")

local Options = {}

local staticObjLayer
local obj
local exitOptions = false

local function waitForMessage()
	-- pull this out so it doesn't get rebuilt every time this is called
	coroutine.yield({		
		game.engineReceiver(), 
		game.M_MsgLoginFacebook_GetMsgTypeId(),
		function(msg)
			game.showFacebookPrompt(msg.login)
		end,
		
		game.gameReceiver(), 
		game.M_MsgKillCoroutine_GetMsgTypeId(),
		function(msg)
			local ROUTINE = "Options"
			if (msg.menu == ROUTINE) then
				print("Killing "..ROUTINE.." Routine...")
				return true
			end
		end
	})
end

Options.show = function()
	local basePriority = 50
	
	local buttons = {}
	
	obj = game.GetGameWorld():createGameObject("GameObject")
	obj:setTag("Options")

	-- BG
	staticObjLayer = game.GetGameWorld():createGameObject("GameObject")
	staticObjLayer:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	
	local bg = staticObjLayer:addSpriteSheet("xml_resources/sprite_main.xml", "background", 0, 0, game.menuScale(), game.menuScale() )
	bg:SetLayerByName("BG")
	bg:SetPriority(basePriority)
	bg:center()
	--bg:setVAnchor(game.Gfx_VA_ALIGN_TOP)
	
	-- bg
	local bgGfx = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_large", 0, 0, game.menuScale(), game.menuScale() )
	bgGfx:SetLayerByName("HUD")
	bgGfx:SetPriority(basePriority-1)
	bgGfx:center()
	
	obj:setPos( game.windowSizeX()*0.5, -bgGfx:height() )


	-- pause text
	local text = game.getLocalizedText("OPTIONS")
	local titleGfx = obj:addTextRaster( game.getMidSizeFont(), text, 0, -bgGfx:height()*0.5*game.menuScale(), game.menuScale(), game.menuScale(), game.GfxText_Format_Center )
	titleGfx:SetLayerByName("HUD")
	titleGfx:SetPriority(basePriority-2)
	titleGfx:center()
	
	local offsetX = -90
	local offsetY = -25
	local spacingY = 30
	
	local closeButton = Button.new("xml_resources/sprite_menu.xml", "btn_close", "HUD", basePriority-2, obj, -175*game.menuScale(), -81*game.menuScale(), true, game.menuScale() )
	closeButton.gameobject:setTag("closeButton")
	closeButton.onTouchUp = function() 
		exitOptions = true
		Options.hide()
	end

	
	-- SFX toggle
	local soundOnText = obj:addTextRaster("zombie_font_description", game.getLocalizedText("OPTIONS_SOUND"), offsetX*game.menuScale(), offsetY*game.menuScale(), 0.5*game.menuScale(), 0.5*game.menuScale())
	soundOnText:SetLayerByName("HUD")
	soundOnText:center()
	soundOnText:SetPriority(basePriority-2)
	
	local soundToggle = ToggleButton.new("xml_resources/sprite_menu.xml", "btn_checkbox_unchecked", "btn_checkbox_checked", "HUD", basePriority-2, game.menuScale())
	soundToggle.gameobject:setParent(obj)
	soundToggle.gameobject:setPos((offsetX + 60)*game.menuScale(), offsetY*game.menuScale())
	
	if game.isSoundOn() == 1 then
		soundToggle:toggle()
	end
	
	soundToggle.onToggle = function (soundToggle)
		game.toggleSound()
	end
	
	-- Music Toggle
	offsetY = offsetY + spacingY
	
	local musicOnText = obj:addTextRaster("zombie_font_description", game.getLocalizedText("OPTIONS_MUSIC"), offsetX*game.menuScale(), offsetY*game.menuScale(), 0.5*game.menuScale(), 0.5*game.menuScale())
	musicOnText:SetLayerByName("HUD")
	musicOnText:center()
	musicOnText:SetPriority(basePriority-2)
	
	local musicToggle = ToggleButton.new("xml_resources/sprite_menu.xml", "btn_checkbox_unchecked", "btn_checkbox_checked", "HUD", basePriority-2, game.menuScale())
	musicToggle.gameobject:setParent(obj)
	musicToggle.gameobject:setPos((offsetX + 60)*game.menuScale(), offsetY*game.menuScale())
	
	if game.isMusicOn() == 1 then
		musicToggle:toggle()
	end
	
	musicToggle.onToggle = function (musicToggle)
		game.toggleMusic()
	end
	
	--Help Screen Toggle
	offsetY = offsetY + spacingY
	
	--[[local helpOnText = obj:addTextRaster("zombie_font_description", game.getLocalizedText("HELP_TUTORIALS"), offsetX, offsetY, 0.5, 0.5)
	helpOnText:SetLayerByName("HUD")
	helpOnText:center()
	helpOnText:SetPriority(basePriority-2)
	
	local tutorialToggle = ToggleButton.new("xml_resources/sprite_menu.xml", "btn_checkbox_unchecked", "btn_checkbox_checked", "HUD", basePriority-2)
	tutorialToggle.gameobject:setParent(obj)
	tutorialToggle.gameobject:setPos(offsetX + 60, offsetY)
	
	if (game.isTutorialOn()) then
		tutorialToggle:toggle()
	end
	
	tutorialToggle.onToggle = function (tutorialToggle)
		game.toggleTutorials()
	end--]]
	
	local creditsButton = Button.new("xml_resources/sprite_menu.xml", "btn_green", "HUD", basePriority-2, obj, (offsetX + 20)*game.menuScale(), 45*game.menuScale(), true, game.menuScale())
	creditsButton:setText(game.getLocalizedText("HELP_TUTORIALS"))
	creditsButton.onTouchUp = function() 
		--show credits
		game.showTutorialSelect()
	end
	
	--Credits
	local creditsButton = Button.new("xml_resources/sprite_menu.xml", "btn_green", "HUD", basePriority-2, obj, 85*game.menuScale(), 45*game.menuScale(), true, game.menuScale())
	creditsButton:setText(game.getLocalizedText("CREDITS"))
	creditsButton.onTouchUp = function() 
		--show credits
		Options.hide()
		menu:pushMenu("credits")
		--game.GetGameWorld():destroyGameObject(obj)
		--game.GetGameWorld():destroyGameObject(root.gameobject)
	end
	
	--Facebook
	
	--[[local facebookText = obj:addTextRaster("zombie_font_description", game.getLocalizedText("FACEBOOK"), 70, -35, 0.4, 0.4)
	facebookText:SetLayerByName("HUD")
	facebookText:center()
	facebookText:SetPriority(basePriority-2)]]
	local facebookButton
	
	if(game.isAndroid()==0) then
		facebookButton = Button.new("xml_resources/sprite_menu.xml", "btn_facebook", "HUD", basePriority-2, obj, 60*game.menuScale(), -15*game.menuScale(), true, game.menuScale())
	else
		facebookButton = Button.new("xml_resources/sprite_menu.xml", "btn_facebook", "HUD", basePriority-2, obj, 88*game.menuScale(), -15*game.menuScale(), true, game.menuScale())
	end
	
	--[[if game.isConnectedToFacebook() == 1 then
		facebookButton:setText(game.getLocalizedText("LOGOUT"))
	else
		facebookButton:setText(game.getLocalizedText("CONNECT"))
	end]]
	
	facebookButton.onTouchUp = function() 
		--facebook connect
		game.toggleFacebook()
	end
	
	--Game Center
	if(game.isAndroid()==0) then
		--[[local gameCenterText = obj:addTextRaster("zombie_font_description", game.getLocalizedText("GAME_CENTER"), 70, 25, 0.4, 0.4)
		gameCenterText:SetLayerByName("HUD")
		gameCenterText:center()
		gameCenterText:SetPriority(basePriority-2)]]
		
		local gcButton = Button.new("xml_resources/sprite_menu.xml", "btn_gamecenter", "HUD", basePriority-2, obj, 115*game.menuScale(), -15*game.menuScale(), true, game.menuScale())
	
	
		--[[if game.isConnectedToGameCenter() == 1 then
			gcButton:setText(game.getLocalizedText("LOGOUT"))
		else
			gcButton:setText(game.getLocalizedText("CONNECT"))
		end]]
		
		gcButton.onTouchUp = function() 
			--launch achievements
			game.showAchievements()
		end
	end
	
	action = obj:wait( 0.5 )
	action:start()
	ActionHelper.waitForAction(action)
	
	-- bring the bg down
	game.playSfx("audio/sfx/woosh2.wav")
	action = obj:movePosition( 0, game.windowSizeY()*0.5+bgGfx:height(), 1.0, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
end

Options.hide = function()
	local obj = game.GetGameWorld():getObjectByTag("Options")
	
	if obj then

		action = obj:movePosition( 0, -game.windowSizeY(), 0.7, lua_sys.Back_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
	
		if (exitOptions == true ) then
			game.GetGameWorld():destroyGameObject(obj)
			game.loadMenu("main_menu")
			
			--[[action = staticObjLayer:wait( 0.1 )
			action:start()
			ActionHelper.waitForAction(action)
	
			if staticObjLayer  then
				game.GetGameWorld():destroyGameObject(staticObjLayer)
			end--]]
		end
	else
		print("Where'd options go?")
	end
	
	game.killCoroutine("Options")
end

Options.show()
waitForMessage()
