local ActionHelper = include("ActionHelper")
local Button = include("Button")
local StatBar = include("StatBar")

local PauseMenu = {}

local obj, bgObj
local totalCoinObj
local buttonObj
local fadedBGObj

local action, action2, action3

local menuScale = game.menuScale()

local totalNumOfCoins = game.getGoldCoins()
local totalNumofPlatinum = game.getPlatinumCoins()

local lastButton = nil

PauseMenu.show = function()
	
	print "pause menu"
	local basePriority = 100
	
	obj = game.GetGameWorld():createGameObject("GameObject")
	obj:setTag("PauseMenu")
	
	bgObj = game.GetGameWorld():createGameObject("GameObject")
	bgObj:setTag("bgObj")
	bgObj:setParent(obj)
	
	fadedBGObj = game.GetGameWorld():createGameObject("GameObject");
	--fadedBGObj:setParent(obj)
	fadedBGObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	fadedBGObj:setTag("FadedBG_pause")
	
	local fadedBG = fadedBGObj:addSprite("gfx/menu/bg/background")
	fadedBGObj:setScale( lua_sys.screenWidth()/fadedBG:width(), lua_sys.screenHeight()/fadedBG:width() )
	fadedBG:SetLayerByName("HUD")
	fadedBG:center()
	fadedBG:SetPriority(basePriority)
	fadedBG:SetAlpha(200)
	
	buttonObj = game.GetGameWorld():createGameObject("GameObject")
	buttonObj:setTag("buttonObj")
	buttonObj:setParent(obj)
	
	totalCoinObj = game.GetGameWorld():createGameObject("GameObject")
	totalCoinObj:setTag("totalCoinObj")
	totalCoinObj:setParent(obj)
	
	--Create buttons
	
	local posY = -80*menuScale
	local offsetPosY = 55*menuScale
	--Resume
	local buttonResume = Button.new("xml_resources/sprite_menu.xml", "tab_blue", "HUD", basePriority-2, buttonObj, 0, posY, true, menuScale)
	buttonResume.gameobject:setTag("buttonResume")
	buttonResume:setText( game.getLocalizedText("RESUME"), nil, 0.4, 0, 15*menuScale  )
	buttonResume:addOverlaySprite( "xml_resources/sprite_menu.xml", "btn_play", 1.0, 1*menuScale, -10 *menuScale )
	buttonResume.onTouchUp = function()
		PauseMenu.hide()
		game.resumeGame()
	end
	
	posY = posY + offsetPosY
	--Replay
	local buttonReplay = Button.new("xml_resources/sprite_menu.xml", "tab_blue", "HUD", basePriority-3, buttonObj, 0, posY, true, menuScale)
	buttonReplay.gameobject:setTag("buttonReplay")
	buttonReplay:setText( game.getLocalizedText("RESTART"), nil, 0.4, 0, 15*menuScale  )
	buttonReplay:addOverlaySprite( "xml_resources/sprite_menu.xml", "btn_replay", 1.0, 1, -10*menuScale  )
	buttonReplay.onTouchUp = function()
		PauseMenu.hide()
		game.restartGame()
	end
	
	posY = posY + offsetPosY
	--Venue Menu
	local buttonVenue = Button.new("xml_resources/sprite_menu.xml", "tab_blue", "HUD", basePriority-4, buttonObj, 0, posY, true, menuScale)
	buttonVenue.gameobject:setTag("buttonVenue")
	buttonVenue:setText( game.getLocalizedText("MENU_VENUE_SELECT"), nil, 0.4, 0, 15*menuScale  )
	buttonVenue:addOverlaySprite( "xml_resources/sprite_menu.xml", "btn_venue", 1.0, 1*menuScale, -10*menuScale  )
	buttonVenue.onTouchUp = function()
		game.showQuitGamePrompt("venue_select")
	end
	
	posY = posY + offsetPosY
	--Main Menu
	local buttonMainMenu = Button.new("xml_resources/sprite_menu.xml", "tab_blue", "HUD", basePriority-5, buttonObj, 0, posY, true, menuScale)
	buttonMainMenu.gameobject:setTag("buttonMainMenu")
	buttonMainMenu:setText( game.getLocalizedText("MAIN_MENU"), nil, 0.4, 0, 15*menuScale  )
	buttonMainMenu:addOverlaySprite( "xml_resources/sprite_menu.xml", "btn_home_small", 1.0, 1*menuScale, -10*menuScale  )
	buttonMainMenu.onTouchUp = function()
		game.showQuitGamePrompt("main_menu")
	end
	
	
	buttonObj:setPos( game.windowSizeX(), game.windowSizeY()*0.5)
	
	-- bg
	local bgGfx = bgObj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_large", 0, 0, menuScale, menuScale)
	bgGfx:SetLayerByName("HUD")
	bgGfx:SetPriority(basePriority-1)
	bgGfx:center()
	
	bgObj:setPos( game.windowSizeX()*0.4, -bgGfx:height()*menuScale )
	
	--Player
	--[[local playerAnimObj = game.GetGameWorld():createGameObject("PlayerAnimObject")
	playerAnimObj:setParent(bgObj)
	
	playerAnimObj = game.CastToPlayerAnim(playerAnimObj)
	playerAnimObj:remapPlayerAnim()
	playerAnimObj:setScale(0.6*menuScale, 0.6*menuScale)
	playerAnimObj:setPos(125*menuScale, 0)
	
	playerAnimObj:getAnim():SetLayerByName("HUD")
	playerAnimObj:getAnim():SetPriority(basePriority-3)
	playerAnimObj:getAnim():center()]]
	--[[local playerAnimObj = game.GetGameWorld():createGameObject("GameObject")
	playerAnimObj:setParent(bgObj)
	playerAnimObj:setScale(0.6, 0.6)
	playerAnimObj:setPos(bgObj:x() - 80, 0)
	playerSprite = playerAnimObj:addAEAnim(game.getPlayerAnim(), 0, 0)
	playerSprite:SetLayerByName("HUD")
	playerSprite:SetPriority(basePriority-3)
	playerSprite:center()
	game.remapPlayerAnim(playerSprite)]]
	
	--Stats
	local xpos = 0
	local ypos = -45*menuScale
	local spacing = 25*menuScale
	local bar1 = StatBar.new(game.getContactStatInfo(), false, "HUD", basePriority-3, bgObj, xpos, ypos+spacing*1)
	local bar2 = StatBar.new(game.getVisionStatInfo(), false, "HUD", basePriority-3, bgObj, xpos, ypos+spacing*2)
	local bar3 = StatBar.new(game.getPowerStatInfo(), false, "HUD", basePriority-3, bgObj, xpos, ypos+spacing*3)
		
	-- results text
	local text = game.getLocalizedText("PAUSE")
	local titleGfx = bgObj:addTextRaster( game.getMidSizeFont(), text, 0, -bgGfx:height()*0.5*menuScale+10*menuScale, 1, 1, game.GfxText_Format_Center )
	titleGfx:SetLayerByName("HUD")
	titleGfx:SetPriority(basePriority-2)
	titleGfx:center()
		
	-- total coin obj
	local totalCoinGfx = totalCoinObj:addSpriteSheet( "xml_resources/bb_icons.xml", "basic_currency_gold_coin_b", 0, 0, 0.7*menuScale, 0.7*menuScale )
	totalCoinGfx:SetLayerByName("HUD")
	totalCoinGfx:SetPriority(basePriority-2)
	totalCoinGfx:center()
	
	-- current total coins
	text = totalNumOfCoins
	totalCoinGfx = totalCoinObj:addTextRaster( game.getDescriptionFont(), text, 25*menuScale, 0, 1*menuScale, 1*menuScale, game.GfxText_Format_Left )
	totalCoinGfx:SetLayerByName("HUD")
	totalCoinGfx:SetPriority(basePriority-2)
	totalCoinGfx:left_center()
	
	-- platinum gfx
	local totalPlatinumGfx = totalCoinObj:addSpriteSheet( "xml_resources/bb_icons.xml", "premium_currency_platinum_coin", 150*menuScale, 0, 0.7*menuScale, 0.7*menuScale )
	totalPlatinumGfx:SetLayerByName("HUD")
	totalPlatinumGfx:SetPriority(basePriority-2)
	totalPlatinumGfx:center()
	
	-- current platinum coins
	text = totalNumofPlatinum
	totalPlatinumGfx = totalCoinObj:addTextRaster( game.getDescriptionFont(), text, 175*menuScale, 0, 1*menuScale, 1*menuScale, game.GfxText_Format_Left )
	totalPlatinumGfx:SetLayerByName("HUD")
	totalPlatinumGfx:SetPriority(basePriority-2)
	totalPlatinumGfx:left_center()
	
	totalCoinObj:setPos( -game.windowSizeX()*0.5, game.windowSizeY() - 30*menuScale)
	
	-- bring the bg down
	game.playSfx("audio/sfx/woosh2.wav")
	action = bgObj:movePosition( 0, game.windowSizeY()*0.5+bgGfx:height()*menuScale, 0.5, lua_sys.Back_EASEOUT )
	-- bring the total coin obj in from left
	game.playSfx("audio/sfx/woosh2.wav")
	action2 = totalCoinObj:movePosition( game.windowSizeX()*0.5+30*menuScale, 0, 0.5, lua_sys.Back_EASEOUT )
	-- bring buttons in from right
	game.playSfx("audio/sfx/woosh2.wav")
	action3 = buttonObj:movePosition( -50*menuScale, 0, 0.5, lua_sys.Quadratic_EASEINOUT )
	
	action:start()
	action2:start()
	action3:start()
	ActionHelper.waitForAction(action)
	ActionHelper.waitForAction(action2)
	ActionHelper.waitForAction(action3)
end

PauseMenu.hide = function()
	local obj = game.GetGameWorld():getObjectByTag("PauseMenu")
	
	if obj then
		game.playSfx("audio/sfx/woosh1.wav")
		action = obj:movePosition( lua_sys.screenWidth() - obj:x(), 0, 0.5, lua_sys.Quadratic_EASEIN )
		action:start()
		action = fadedBGObj:moveAlpha( -1.0, 0.5, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		
		print("Destroy Gameove Menu")
		game.GetGameWorld():destroyGameObject(obj)	
		game.GetGameWorld():destroyGameObject(fadedBGObj)		
	else
		print("Where'd options go?")
	end
	
	game.killStoreRoutine()
	
end

PauseMenu.show()