local Button = include("Button")
local ToggleButton = include("ToggleButton")

PowerUpItem = {}

local menuScale = game.menuScale()

PowerUpItem.new = function(data, layer, priority, parent, xPos, yPos, inGame, restartLevel)

	local item = {}
	
	local obj = game.GetGameWorld():createGameObject("GameObject");
	obj:setTag("PowerUpItem")
	item.gameobject = obj
	
	local bg = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_small", 0, 0, menuScale, menuScale)
	bg:SetLayerByName("HUD")
	bg:center()
	bg:SetPriority(priority)
		
	item.height = bg:height()
	
	print ("in Game "..inGame)
	if( inGame == 0 ) then 
	
		if(data.name_~="POWER_UP_HOT_TUB" or game.getContactStatInfo().fatigue_>0) then
			print "not in game"
			local powerupToggle = ToggleButton.new("xml_resources/sprite_menu.xml", "btn_checkbox_unchecked", "btn_checkbox_checked", "HUD", priority-2, menuScale)
			powerupToggle.gameobject:setParent(obj)
			powerupToggle.gameobject:setPos(-bg:width()*0.5*menuScale+26*menuScale, -4*menuScale)
			
			game.getContactStatInfo()
			
			if game.isPowerupActivated(data) == 1 then
				powerupToggle:toggle()
			end
			
			powerupToggle.onToggle = function (powerupToggle)
				if( restartLevel == 1 ) then
					game.togglePowerUp(data, false)
				else
					game.togglePowerUp(data, true)
				end
			end
			
			item.toggleButton = powerupToggle
		end
	else
		--[[local toggleSprite = nil
		if (game.isPowerupActivated(data) == 1) then
			toggleSprite = obj:addSpriteSheet("xml_resources/sprite_menu.xml",  "btn_checkbox_checked", -bg:width()*0.5+26, -4)
		else
			toggleSprite = obj:addSpriteSheet("xml_resources/sprite_menu.xml",  "btn_checkbox_unchecked", -bg:width()*0.5+26, -4)
		end
		
		toggleSprite:SetLayerByName("HUD")
		toggleSprite:center()
		toggleSprite:SetPriority(priority-1)--]]
	end
	
	
	local itemSprite = nil
	itemSprite = obj:addSpriteSheet(data.spriteSheetFile_, data.spriteName_, -bg:width()*0.5*menuScale+80*menuScale, -4*menuScale, 0.5*menuScale, 0.5*menuScale) 
	itemSprite:SetLayerByName("HUD")
	itemSprite:center()
	itemSprite:SetPriority(priority-1)
	
	
	local font = "zombie_font_description"
	
	local font = "zombie_font_description"
	local name = game.getLocalizedText(data.name_)
	local tempObj = game.GetGameWorld():createGameObject("GameObject")
	local textX = -12*menuScale
	local tempGfx = tempObj:addTextRaster(font, name, textX, 0*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Center, 150*menuScale, true )
	
	if(tempGfx:numLines() == 1) then
		textGfx = obj:addTextRaster(font, name, textX, 0*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Center, 150*menuScale, true )
	elseif(tempGfx:numLines() == 2) then
		textGfx = obj:addTextRaster(font, name, textX, -8*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Center, 150*menuScale, true )
	else
		textGfx = obj:addTextRaster(font, name, textX, -14*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Center, 150*menuScale, true )
	end
	
	--textGfx = obj:addTextRaster(font, game.getLocalizedText(data.name_), -12, 0, 0.45, 0.45, game.GfxText_Format_Center, 150)
	textGfx:SetLayerByName(layer)
	textGfx:center()
	textGfx:SetPriority(priority-1)
	item.name = textGfx
	
	if(data.name_=="POWER_UP_HOT_TUB" and game.getContactStatInfo().fatigue_==0) then
		itemSprite:SetColorProper(255,255,255,100)
		textGfx:SetColorProper(255,255,255,100)
	end
	
	item.layer = layer or "HUD"
	item.priority = priority or 50
	
	
	if parent then
		obj:setParent(parent)
	end
	
	local x = xPos or 0
	local y = yPos or 0
	obj:setPos(x, y)
		
	--button to send a gift to this friend
	print ("y: ", obj:y() )
	local moreInfoButton = Button.new("xml_resources/sprite_menu.xml", "btn_yellow", "HUD", priority-2, obj, 120*menuScale, 0*menuScale, true, menuScale)
	moreInfoButton.gameobject:setTag("MoreInfoButton")
	moreInfoButton:setText( game.getLocalizedText("MORE_INFO") )
	moreInfoButton.onTouchUp = function() 
		--[[game.sendGiftRequest(item.fbid)]]
		game.showPowerUpInfo(data, inGame)
	end

	item.moreInfoButton = moreInfoButton
	item.updateToggle = function(toggle)
		print "hello"
		item.toggleButton.updateToggle(toggle)
	end
		
	return item

end

return PowerUpItem


