--local nameText, descText, power, contact, vision, numOwned, spriteSheet, spriteName, inGame = ...
nameText, descText, numOwned, spriteSheet, spriteName, inGame = ...

local ActionHelper = include("ActionHelper")
local Button = include("Button")

local menuScale = game.menuScale()

local PowerUpItemInfo = {}

PowerUpItemInfo.show = function()
	local obj = game.GetGameWorld():createGameObject("GameObject");
	obj:setTag("PowerUpItemInfo")

	local basePriority = 40

	local fadedBGObj = game.GetGameWorld():createGameObject("GameObject");
	fadedBGObj:setParent(rootObj)
	fadedBGObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	fadedBGObj:setTag("FadedBG_p")
	
	local fadedBG = fadedBGObj:addSprite("gfx/menu/bg/background")
	fadedBGObj:setScale( lua_sys.screenWidth()/fadedBG:width(), lua_sys.screenHeight()/fadedBG:width() )
	fadedBG:SetLayerByName("POPUP")
	fadedBG:center()
	fadedBG:SetPriority(basePriority)
	fadedBG:SetAlpha(200)
	
	local bg = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_medium", 0, 0, menuScale, menuScale)
	
	bg:SetLayerByName("POPUP")
	bg:center()
	bg:SetPriority(basePriority-1)

	local closeButton = Button.new("xml_resources/sprite_menu.xml", "btn_close", "POPUP", basePriority-2, obj, -175*menuScale, -bg:height() * 0.5*menuScale + 10*menuScale)
	closeButton.onTouchUp = function() 
		PowerUpItemInfo.hide()
	end
	
	local mainButton = Button.zone("POPUP", basePriority-1, obj, 0, 0, lua_sys.screenWidth(), lua_sys.screenHeight())
	mainButton.onTouchUp = function() 
		PowerUpItemInfo.hide()
	end
	
	local touch = obj:addTouch( lua_sys.screenWidth(), lua_sys.screenHeight(), basePriority )
	touch:setAnchor( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	touch:setEnabled(1)
	
	

	local textObj = game.GetGameWorld():createGameObject("GameObject");
	textObj:setTag("ObjectiveItemInfoText")
	
	local itemSprite = nil
	print ("spriteName = "..spriteName)
	itemSprite = textObj:addSpriteSheet(spriteSheet, spriteName, -bg:width()*0.5*menuScale+20*menuScale, -10, 0.7*menuScale, 0.7*menuScale) 
	itemSprite:SetLayerByName("POPUP")
	itemSprite:left_center()
	itemSprite:SetPriority(basePriority-2)
	
	local objName = textObj:addTextRaster("zombie_font_description", game.getLocalizedText(nameText), 25*menuScale, -37*menuScale, 0.7*menuScale, 0.7*menuScale, game.GfxText_Format_Center, 300*menuScale, true )
	objName:SetLayerByName("POPUP")
	objName:center()
	objName:SetPriority(basePriority-2)
	
	local objDesc = textObj:addTextRaster("zombie_font_description", game.getLocalizedText(descText), 25*menuScale, -5*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Center, 250*menuScale, true )
	objDesc:SetLayerByName("POPUP")
	objDesc:center()
	--objDesc:SetColorProper( 204, 255, 255, 255 )
	objDesc:SetPriority(basePriority-2)
	
	--[[if( power > 0 ) then
		local objPowerStats = textObj:addTextRaster("zombie_font_description", (game.getLocalizedText("POWER")..": +"..power), 20, 30, 0.45, 0.45, game.GfxText_Format_Left, 250, true )
		objPowerStats:SetLayerByName("POPUP")
		objPowerStats:center()
		objPowerStats:SetPriority(basePriority-2)
	elseif ( contact > 0 ) then
		local objPowerStats = textObj:addTextRaster("zombie_font_description", (game.getLocalizedText("CONTACT")..": +"..contact), 20, 30, 0.45, 0.45, game.GfxText_Format_Left, 250, true )
		objPowerStats:SetLayerByName("POPUP")
		objPowerStats:center()
		objPowerStats:SetPriority(basePriority-2)
	elseif ( vision > 0 ) then
		local objPowerStats = textObj:addTextRaster("zombie_font_description", (game.getLocalizedText("VISION")..": +"..vision), 20, 30, 0.45, 0.45, game.GfxText_Format_Left, 250, true )
		objPowerStats:SetLayerByName("POPUP")
		objPowerStats:center()
		objPowerStats:SetPriority(basePriority-2)
	end]]
	
	local text = game.getLocalizedText("OWNED")
	if( inGame == 1 ) then
		text = game.getLocalizedText("ACTIVE")
	end
	
	text = text..numOwned
	
	local objNumOwned = textObj:addTextRaster("zombie_font_description", text, -bg:width()*0.5*menuScale+20*menuScale, 30*menuScale, 0.45*menuScale, 0.45*menuScale, game.GfxText_Format_Left, 100*menuScale, true )
	objNumOwned:SetLayerByName("POPUP")
	objNumOwned:left_center()
	objNumOwned:SetPriority(basePriority-2)

	
	textObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	textObj:setAlpha(0.0)
	
	obj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	obj:setScale(0.0, 1.0)
	
	local action = obj:moveScale( 1.0, 0, 0.45, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)

	action = textObj:moveAlpha( 1.0, 0.15, lua_sys.Quadratic_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
	
	touch:setEnabled(1)
	
end

PowerUpItemInfo.hide = function()

	local obj = game.GetGameWorld():getObjectByTag("PowerUpItemInfo")
	local textObj = game.GetGameWorld():getObjectByTag("ObjectiveItemInfoText")
	local FadedBGObj = game.GetGameWorld():getObjectByTag("FadedBG_p")
	if obj then
		local action = textObj:moveAlpha( -1.0, 0.1, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
	
		action = obj:moveScale( -1.0, 0, 0.25, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		
		game.GetGameWorld():destroyGameObject(textObj)
		game.GetGameWorld():destroyGameObject(FadedBGObj)
		game.GetGameWorld():destroyGameObject(obj)
	end

end

PowerUpItemInfo.show()