local obj = ...

local ActionHelper = include("ActionHelper")
local usingMagnet = false
local objContacted = nil
local destroyObj = false

coroutine.yield({
	obj, 
	game.M_MsgGameObjectContact_GetMsgTypeId(),
	function(msg)
		
		objContacted = msg.other
		if( msg.shapeB == "BALL") then
			print ("Colliding with Ball")
			return true
		elseif( msg.shapeB == "BALL_MAGNET" ) then
			usingMagnet = true
			return true
		end
		return false
	end })

obj:killPhysics()
game.gameReceiver():Send(game.MsgPickupCollected("PowerupPickup", obj))

if( usingMagnet == false ) then
	game.playSfx("audio/sfx/collect_powerup.wav")
	local t_action = obj:movePosition( -obj:x(), -obj:y(), 1, lua_sys.Back_EASEINOUT )
	t_action:start()
	ActionHelper.waitForAction(t_action)
else
	--print "using Magnet"
	local xPos = math.floor(obj:x())
	local yPos = math.floor(obj:y())
	local ballPosX = math.floor(objContacted:x())
	local ballPosY = math.floor(objContacted:y())
	local incAmount = 1.0
	
	coroutine.yield({
			game.engineReceiver(), 
			game.M_MsgUpdate_GetMsgTypeId(),
			function(msg) 
				if( destroyObj == false ) then
					if(xPos ~= ballPosX or yPos ~= ballPosY) then
						
						if( xPos < ballPosX ) then
							xPos = xPos + incAmount
							if( xPos > ballPosX ) then
								xPos = ballPosX
							end
						elseif( xPos > ballPosX ) then
							xPos = xPos - incAmount
							if( xPos < ballPosX ) then
								xPos = ballPosX
							end
						end
						
						if( yPos < ballPosY ) then
							yPos = yPos + incAmount
							if( yPos > ballPosY ) then
								yPos = ballPosY
							end
						elseif( yPos > ballPosY ) then
							yPos = yPos - incAmount
							if( yPos < ballPosY ) then
								yPos = ballPosY
							end
						end
								
						--print ("objx: "..xPos.." objy: "..yPos)
						--print ("ballx: "..ballPosX.." bally: "..ballPosY)
						if( xPos == ballPosX and yPos == ballPosY ) then
							destroyObj = true
							game.playSfx("audio/sfx/collect_powerup.wav")
							return true
						else
							obj:setPos( xPos, yPos )
						
							xPos = math.floor(obj:x())
							yPos = math.floor(obj:y())
							ballPosX = math.floor(objContacted:x())
							ballPosY = math.floor(objContacted:y())
							incAmount = incAmount + 1.0
						end
					else
						destroyObj = true
						game.playSfx("audio/sfx/collect_powerup.wav")
						return true
					end
				end
			end
		})
end

game.GetGameWorld():destroyGameObject(obj)
	
