local ActionHelper = include("ActionHelper")

ProgressBar = {}

local menuScale = game.menuScale()

ProgressBar.new = function(baseTexture, fillTexture, layer, priority, parent, xPos, yPos)
	local ProgressBar = {}
	
	ProgressBar.layer = layer or "HUD"
	ProgressBar.priority = priority or 50
	
	local obj = game.GetGameWorld():createGameObject("GameObject");
	ProgressBar.gameobject = obj
	if parent then
		obj:setParent(parent)
	end
	
	local x = xPos or 0
	local y = yPos or 0
	obj:setPos(x, y)
	
	--------------------------]
	--local text = statData.statName_ .. ": " .. (playerStat+equipmentStat)
	--------------------------]
	local bar_width = 0

	local bar_base = obj:addSprite( baseTexture, x, y, menuScale, menuScale )
	bar_base:SetLayerByName(ProgressBar.layer)
	bar_base:SetPriority(ProgressBar.priority-1)
	bar_base:center()
	bar_width = bar_base:width()
	--bar_base:SetMask(0, 0, bar_width, bar_base:height())	
	
	local bar_fill = obj:addSprite( fillTexture, x, y, menuScale, menuScale )
	bar_fill:SetLayerByName(ProgressBar.layer)
	bar_fill:SetPriority(ProgressBar.priority-2)
	bar_fill:center()
	bar_fill:SetMask(0, 0, 0, bar_fill:height())
	bar_height = (bar_fill:height())
	
	function ProgressBar:setPercent(pct, speed)
		local fill_width = (bar_width * pct)
		local num = 0
		local delay = speed or 0.01
		while (num <= fill_width) do
			print("num = "..num)
			print("fill_width = "..fill_width)
			print("fill_height = "..bar_height)
			bar_fill:SetMask(0, 0, num, bar_height)
			if (delay ~= 0) then
				action = obj:wait( delay )
				action:start()
				ActionHelper.waitForAction(action)
			end
			num = num + 1
		end
	end
	
	function ProgressBar:setText(text)
		local font = font or "zombie_font_description"
		local textGfx = obj:addTextRaster(font, text, x, y, 0.4*menuScale, 0.4*menuScale)
		textGfx:SetLayerByName(ProgressBar.layer)
		textGfx:center()
		textGfx:SetPriority(ProgressBar.priority-4)
	end

	--[[local font = font or "zombie_font_description"
	local textGfx = obj:addTextRaster(font, text, 0, 1, 0.4, 0.4)
	textGfx:SetLayerByName(ProgressBar.layer)
	textGfx:center()
	textGfx:SetPriority(ProgressBar.priority-4)--]]
		
	return ProgressBar
end

return ProgressBar