challengeUnlocked = ...

local ActionHelper = include("ActionHelper")
local Button = include("Button")

local GameOverMenu = {}

local obj, bgObj
local coinObj, platinumObj, totalCoinObj
local scoreObj
local buttonObj

local action, action2, action3

local menuScale = game.menuScale()

local totalNumOfCoins = game.getGoldCoins() - game.getGoldRewardCoinsEarned()
local totalNumofPlatinum = game.getPlatinumCoins() - game.getPlatinumRewardCoinsEarned()
local numCoinsCollected = game.getGoldCoinsEarned()
local numPlatinumCollected = game.getPlatinumCoinsEarned()

-- update players gold and platinum coins
game.addGoldCoins(numCoinsCollected - game.getGoldRewardCoinsEarned())
game.addPlatinumCoins(numPlatinumCollected - game.getPlatinumRewardCoinsEarned())

local lastButton = nil

GameOverMenu.show = function()
	
	print "game over menu"
	local basePriority = 100
	
	obj = game.GetGameWorld():createGameObject("GameObject")
	obj:setTag("GameOverMenu")
	
	bgObj = game.GetGameWorld():createGameObject("GameObject")
	bgObj:setTag("bgObj")
	bgObj:setParent(obj)
	
	buttonObj = game.GetGameWorld():createGameObject("GameObject")
	buttonObj:setTag("buttonObj")
	buttonObj:setParent(obj)
	 	 
	coinObj = game.GetGameWorld():createGameObject("GameObject")
	coinObj:setTag("coinObj")
	coinObj:setParent(obj)
	
	platinumObj = game.GetGameWorld():createGameObject("GameObject")
	platinumObj:setTag("platinumObj")
	platinumObj:setParent(obj)
	
	totalCoinObj = game.GetGameWorld():createGameObject("GameObject")
	totalCoinObj:setTag("totalCoinObj")
	totalCoinObj:setParent(obj)
	
	scoreObj = game.GetGameWorld():createGameObject("GameObject")
	scoreObj:setTag("scoreObj")
	scoreObj:setParent(obj)

	--Create buttons
	
	local posY = -110*menuScale
	local offsetPosY = 55*menuScale
	local createChallengeButton = false
	
	-- if the player has unlocked challenge mode
	if( challengeUnlocked == 1 ) then
		posY = -131*menuScale
		offsetPosY = 53*menuScale
		createChallengeButton = true
	end
	
	--Replay
	local buttonObjectives = Button.new("xml_resources/sprite_menu.xml", "tab_blue", "HUD", basePriority-2, buttonObj, 0, posY, true, menuScale)
	buttonObjectives.gameobject:setTag("buttonReplay")
	buttonObjectives:setText( game.getLocalizedText("RESTART"), nil, 0.4, 0, 15*menuScale  )
	buttonObjectives:addOverlaySprite( "xml_resources/sprite_menu.xml", "btn_replay", 1.0, 1*menuScale, -10*menuScale  )
	buttonObjectives.onTouchUp = function()
		game.refreshPowerupList()
		local powerups = game.getPlayerItems(6)
		if( powerups:size() > 0 ) then
			game.showPowerUpSummary(false, true)
		else
			game.restartGame()
		end
	end
	
	posY = posY + offsetPosY
	--Objectives Summary	
	local buttonObjectives = Button.new("xml_resources/sprite_menu.xml", "tab_blue", "HUD", basePriority-3, buttonObj, 0, posY, true, menuScale)
	buttonObjectives.gameobject:setTag("buttonObjectives")
	buttonObjectives:setText( game.getLocalizedText("OBJECTIVES"), nil, 0.4, 0, 15*menuScale  )
	buttonObjectives:addOverlaySprite( "xml_resources/sprite_menu.xml", "btn_objectives", 1.0, 1*menuScale, -10*menuScale  )
	buttonObjectives.onTouchUp = function()
		game.showObjectiveSummary(true)
	end
	
	posY = posY + offsetPosY
	--Venues
	local buttonMainMenu = Button.new("xml_resources/sprite_menu.xml", "tab_blue", "HUD", basePriority-4, buttonObj, 0, posY, true, menuScale)
	buttonMainMenu.gameobject:setTag("buttonVenues")
	buttonMainMenu:setText( game.getLocalizedText("MENU_VENUE_SELECT"), nil, 0.4, 0, 15*menuScale  )
	buttonMainMenu:addOverlaySprite( "xml_resources/sprite_menu.xml", "btn_venue", 1.0, 1*menuScale, -10*menuScale  )
	buttonMainMenu.onTouchUp = function()
		GameOverMenu.hide("venue_select")
	end
	
	posY = posY + offsetPosY
	--Main Menu
	local buttonMainMenu = Button.new("xml_resources/sprite_menu.xml", "tab_blue", "HUD", basePriority-5, buttonObj, 0, posY, true, menuScale)
	buttonMainMenu.gameobject:setTag("buttonMainMenu")
	buttonMainMenu:setText( game.getLocalizedText("MAIN_MENU"), nil, 0.4, 0, 15*menuScale  )
	buttonMainMenu:addOverlaySprite( "xml_resources/sprite_menu.xml", "btn_home_small", 1.0, 1*menuScale, -10*menuScale  )
	buttonMainMenu.onTouchUp = function()
		GameOverMenu.hide("main_menu")
	end
	
	posY = posY + offsetPosY
	--Store Menu
	local buttonStoreMenu = Button.new("xml_resources/sprite_menu.xml", "tab_blue", "HUD", basePriority-5, buttonObj, 0, posY, true, menuScale)
	buttonStoreMenu.gameobject:setTag("buttonStoreMenu")
	buttonStoreMenu:setText( game.getLocalizedText("STORE_TITLE"), nil, 0.4, 0, 15*menuScale  )
	buttonStoreMenu:addOverlaySprite( "xml_resources/sprite_menu.xml", "btn_shop", 1.0, 1*menuScale, -10*menuScale  )
	buttonStoreMenu.onTouchUp = function()
		GameOverMenu.hide("shop_menu")
	end
	
	if( createChallengeButton == true ) then
		posY = posY + offsetPosY
		--Continue
		local buttonContinue = Button.new("xml_resources/sprite_menu.xml", "tab_blue", "HUD", basePriority-5, buttonObj, 0, posY, true, menuScale)
		buttonContinue.gameobject:setTag("buttonContinue")
		buttonContinue:setText( game.getLocalizedText("CHALLENGE"), nil, 0.4, 0, 15*menuScale  )
		buttonContinue:addOverlaySprite( "xml_resources/sprite_menu.xml", "btn_play", 1.0, 1*menuScale, -10*menuScale  )
		buttonContinue.onTouchUp = function()
			--GameOverMenu.hide("shop_menu")
			--game.setCurrentVenue(nextVenueId)
			game.startChallenge()
		end
	end
	
	
	buttonObj:setPos( game.windowSizeX()+70*menuScale, game.windowSizeY()*0.5)
	
	-- bg
	local bgGfx = bgObj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_large", 0, 0, menuScale, menuScale)
	bgGfx:SetLayerByName("HUD")
	bgGfx:SetPriority(basePriority-1)
	bgGfx:center()
	
	bgObj:setPos( game.windowSizeX()*0.4, -bgGfx:height()*menuScale )
		
	-- results text
	local text = game.getLocalizedText("RESULTS")
	local titleGfx = bgObj:addTextRaster( game.getMidSizeFont(), text, 0, -bgGfx:height()*0.5*menuScale+10*menuScale, 1*menuScale, 1*menuScale, game.GfxText_Format_Center )
	titleGfx:SetLayerByName("HUD")
	titleGfx:SetPriority(basePriority-2)
	titleGfx:center()
		
	-- total coin obj
	local totalCoinGfx = totalCoinObj:addSpriteSheet( "xml_resources/bb_icons.xml", "basic_currency_gold_coin_b", 0, 0, 0.7*menuScale, 0.7*menuScale )
	totalCoinGfx:SetLayerByName("HUD")
	totalCoinGfx:SetPriority(basePriority-2)
	totalCoinGfx:center()
	
	-- current total coins
	text = totalNumOfCoins
	totalCoinGfx = totalCoinObj:addTextRaster( game.getDescriptionFont(), text, 25*menuScale, 0, 1*menuScale, 1*menuScale, game.GfxText_Format_Left )
	totalCoinGfx:SetLayerByName("HUD")
	totalCoinGfx:SetPriority(basePriority-2)
	totalCoinGfx:left_center()
	
	-- platinum gfx
	local totalPlatinumGfx = totalCoinObj:addSpriteSheet( "xml_resources/bb_icons.xml", "premium_currency_platinum_coin", 150*menuScale, 0, 0.7*menuScale, 0.7*menuScale )
	totalPlatinumGfx:SetLayerByName("HUD")
	totalPlatinumGfx:SetPriority(basePriority-2)
	totalPlatinumGfx:center()
	
	-- number of platinum coins
	text = totalNumofPlatinum
	totalPlatinumGfx = totalCoinObj:addTextRaster( game.getDescriptionFont(), text, 175*menuScale, 0, 1*menuScale, 1*menuScale, game.GfxText_Format_Left )
	totalPlatinumGfx:SetLayerByName("HUD")
	totalPlatinumGfx:SetPriority(basePriority-2)
	totalPlatinumGfx:left_center()
	
	totalCoinObj:setPos( -game.windowSizeX()*0.5, game.windowSizeY() - 30*menuScale)
	
	--Objects Destroyed
	--[[text = game.getLocalizedText("TOTAL_OBJECTS_DESTROYED")
	local destroyTitleGfx = bgObj:addTextRaster( game.getDescriptionFont(), text, -15, -10, 0.7, 0.7, game.GfxText_Format_Right )
	destroyTitleGfx:SetLayerByName("HUD")
	destroyTitleGfx:SetPriority(basePriority-2)
	destroyTitleGfx:right_center()
	
	text = 10000
	local objDestroyedGfx = bgObj:addTextRaster( game.getDescriptionFont(), text, 15, -10, 0.7, 0.7, game.GfxText_Format_Left )
	objDestroyedGfx:SetLayerByName("HUD")
	objDestroyedGfx:SetPriority(basePriority-2)
	objDestroyedGfx:left_center()
	]]
	
	-- bring the bg down
	game.playSfx("audio/sfx/woosh2.wav")
	action = bgObj:movePosition( 0, game.windowSizeY()*0.5+bgGfx:height()*menuScale, 0.5, lua_sys.Back_EASEOUT )
	game.playSfx("audio/sfx/woosh2.wav")
	action2 = totalCoinObj:movePosition( game.windowSizeX()*0.5+30*menuScale, 0, 0.5, lua_sys.Back_EASEOUT )
	
	action:start()
	action2:start()
	-- bring the total coin obj in from left

	ActionHelper.waitForAction(action)
	ActionHelper.waitForAction(action2)
	
	--Score
	text = game.getLocalizedText("TOTAL_SCORE")
	local scoreTitleGfx = scoreObj:addTextRaster( game.getDescriptionFont(), text, -15*menuScale, -30*menuScale, 0.7, 0.7, game.GfxText_Format_Right )
	scoreTitleGfx:SetLayerByName("HUD")
	scoreTitleGfx:SetPriority(basePriority-2)
	scoreTitleGfx:right_center()
	
	text = game.getScore()
	local scoreGfx = scoreObj:addTextRaster( game.getDescriptionFont(), text, 15*menuScale, -30*menuScale, 0.7*menuScale, 0.7*menuScale, game.GfxText_Format_Left )
	scoreGfx:SetLayerByName("HUD")
	scoreGfx:SetPriority(basePriority-2)
	scoreGfx:left_center()
	
	scoreObj:setPos( 0, game.windowSizeY()*0.5 )
	
	game.playSfx("audio/sfx/woosh2.wav")
	action = scoreObj:movePosition( game.windowSizeX()*0.4, 0, 0.7, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
	
	--Coins
	local coinGfx = coinObj:addSpriteSheet( "xml_resources/bb_icons.xml", "basic_currency_gold_coin_b", -15*menuScale, 5*menuScale, 0.45*menuScale, 0.45*menuScale )
	coinGfx:SetLayerByName("HUD")
	coinGfx:SetPriority(basePriority-2)
	coinGfx:right_center()
	
	coinObj:setPos( 0, game.windowSizeY()*0.5 )
	
	text = numCoinsCollected
	local coinTextGfx = coinObj:addTextRaster( game.getDescriptionFont(), text, 15*menuScale, 5*menuScale, 0.7*menuScale, 0.7*menuScale, game.GfxText_Format_Left )
	coinTextGfx:SetLayerByName("HUD")
	coinTextGfx:SetPriority(basePriority-2)
	coinTextGfx:left_center()
	
	game.playSfx("audio/sfx/woosh2.wav")
	action = coinObj:movePosition( game.windowSizeX()*0.4, 0, 0.7, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
	
	-- update persistent data
	--game.addGoldCoins(numCoinsCollected)
	
	-- add the coins collected in the round to the total player coins
	while numCoinsCollected >= 0 do
	
		-- update round coin text
		text = numCoinsCollected
		coinTextGfx:changeText(text)
		action = obj:wait( 0.02 )
		action:start()
		ActionHelper.waitForAction(action)
		
		local decrement = 1
		if(numCoinsCollected>1000) then
			decrement = 500
		elseif(numCoinsCollected>100) then
			decrement = 25
		elseif(numCoinsCollected>10) then
			decrement = 5
		elseif(numCoinsCollected>0) then
			decrement = 1
		end
		
		-- update total coin text
		if( numCoinsCollected > 0 ) then 
			totalNumOfCoins = totalNumOfCoins + decrement
			text = totalNumOfCoins
			totalCoinGfx:changeText(text)
			game.playSfx("audio/sfx/collect_coin.wav")
		end
		
		numCoinsCollected = numCoinsCollected - decrement
			
		
	end
	
	--Platinum Coins
	local platinumGfx = platinumObj:addSpriteSheet( "xml_resources/bb_icons.xml", "premium_currency_platinum_coin", -15*menuScale, 45*menuScale, 0.45*menuScale, 0.45*menuScale )
	platinumGfx:SetLayerByName("HUD")
	platinumGfx:SetPriority(basePriority-2)
	platinumGfx:right_center()
	
	platinumObj:setPos( 0, game.windowSizeY()*0.5 )
	
	text = numPlatinumCollected
	platinumGfx = platinumObj:addTextRaster( game.getDescriptionFont(), text, 15*menuScale, 45*menuScale, 0.7*menuScale, 0.7*menuScale, game.GfxText_Format_Left )
	platinumGfx:SetLayerByName("HUD")
	platinumGfx:SetPriority(basePriority-2)
	platinumGfx:left_center()
	
	game.playSfx("audio/sfx/woosh2.wav")
	action = platinumObj:movePosition( game.windowSizeX()*0.4, 0, 0.7, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
	
	-- update persistent data
	--game.addPlatinumCoins(numPlatinumCollected)
	
	-- add the platinum coins collected in the round to the total player platinum coins
	while numPlatinumCollected >= 0 do
	
		-- update round coin text
		text = numPlatinumCollected
		platinumGfx:changeText(text)
		action = obj:wait( 0.03 )
		action:start()
		ActionHelper.waitForAction(action)
		
		-- update total coin text
		if (numPlatinumCollected > 0 ) then
			totalNumofPlatinum = totalNumofPlatinum + 1
			text = totalNumofPlatinum
			totalPlatinumGfx:changeText(text)
			game.playSfx("audio/sfx/collect_coin.wav")
		end
		
		numPlatinumCollected = numPlatinumCollected - 1
	end
	
	game.playSfx("audio/sfx/woosh2.wav")
	action3 = buttonObj:movePosition( -(50+70)*menuScale, 0, 0.5, lua_sys.Quadratic_EASEINOUT )
	action3:start()
	ActionHelper.waitForAction(action3)
		
end

GameOverMenu.hide = function(menuToLoad)
	local targetMenu = menuToLoad or "venue_select"
	local obj = game.GetGameWorld():getObjectByTag("GameOverMenu")
	--local staticObjLayer = game.GetGameWorld():getObjectByTag("StaticObjLayer")
	
	if obj then
		game.playSfx("audio/sfx/woosh1.wav")
		action = obj:movePosition( lua_sys.screenWidth() - obj:x(), 0, 0.5, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		
		print("Destroy Gameove Menu")
		game.GetGameWorld():destroyGameObject(obj)		
		
		game.quitGame(targetMenu)
	else
		print("Where'd options go?")
	end
	
	
end

GameOverMenu.show()
