local result = ...

local ActionHelper = include("ActionHelper")
local Button = include("Button")

local menuScale = game.menuScale()
local SocialPopUp = {}

SocialPopUp.show = function()
	--All the generic stuff
	local basePriority = 10

	local obj = game.GetGameWorld():createGameObject("GameObject");
	obj:setTag("SocialPopUp")
	
	local textObj = game.GetGameWorld():createGameObject("GameObject");
	textObj:setTag("SocialPopUpText")
	
	local fadedBGObj = game.GetGameWorld():createGameObject("GameObject");
	fadedBGObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	fadedBGObj:setTag("FadedBG2")
	
	local fadedBG = fadedBGObj:addSprite("gfx/menu/bg/background")
	fadedBGObj:setScale( lua_sys.screenWidth()/fadedBG:width(), lua_sys.screenHeight()/fadedBG:width() )
	fadedBG:SetLayerByName("POPUP")
	fadedBG:center()
	fadedBG:SetPriority(basePriority)
	fadedBG:SetAlpha(200)
	
	local touch = obj:addTouch( lua_sys.screenWidth(), lua_sys.screenHeight(), basePriority )
	touch:setAnchor( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	touch:setEnabled(1)

	local titleText = "Facebook"
	local infoText = "Successfully Logged In"
	
	if( result == 0 ) then
		infoText = "Successfully Logged Out" 
	end
	
	local bg = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_small", 0, 0, 0.7*menuScale, 1.*menuScale)
	bg:SetLayerByName("POPUP")
	bg:center()
	bg:SetPriority(basePriority-1)
	
	local title = textObj:addTextRaster("zombie_font_description", game.getLocalizedText(titleText), 0, -bg:height()/2*menuScale, 0.6*menuScale, 0.6*menuScale, game.GfxText_Format_Center, bg:width()*menuScale-20*menuScale, true )
	title:SetLayerByName("POPUP")
	title:center()
	title:SetPriority(basePriority-2)

	local description = textObj:addTextRaster("zombie_font_description", game.getLocalizedText(infoText), 0, 0, 0.45*menuScale, 0.45*menuScale, game.GfxText_Format_Center, bg:width()*menuScale-20*menuScale, true )
	description:SetLayerByName("POPUP")
	description:center()
	description:SetPriority(basePriority-2)
	
	local okButton = Button.new("xml_resources/sprite_menu.xml", "btn_green", "POPUP", basePriority-2, obj, 0, bg:height()*menuScale*0.8)
	okButton:setText("OK")
	okButton.onTouchUp = function() 
		SocialPopUp.hide()
	end

	
	--Animate in
	textObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	textObj:setAlpha(0.0)
	
	obj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	obj:setScale(0.0, 1.0)
	
	local action = obj:moveScale( 1.0, 0, 0.45, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)

	action = textObj:moveAlpha( 1.0, 0.15, lua_sys.Quadratic_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
end

SocialPopUp.hide = function()

	local obj = game.GetGameWorld():getObjectByTag("SocialPopUp")
	local textObj = game.GetGameWorld():getObjectByTag("SocialPopUpText")
	local fadedBGObj = game.GetGameWorld():getObjectByTag("FadedBG2")
	if obj then
		local action = textObj:moveAlpha( -1.0, 0.1, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		
		if fadedBGObj then
			game.GetGameWorld():destroyGameObject(fadedBGObj)
		end
	
		action = obj:moveScale( -1.0, 0, 0.25, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		
		game.GetGameWorld():destroyGameObject(textObj)
		game.GetGameWorld():destroyGameObject(obj)
		game.gameReceiver():Send(game.MsgContinueGame())
	end

end

SocialPopUp.show()