-- StatBar : assumes you want to use gfxspritesheet images for the statbar states;
-- statbar touch area is the size of the up sprite

StatBar = {}

local menuScale = game.menuScale()

StatBar.new = function(statData, showTempStats, layer, priority, parent, xPos, yPos)

	local statbar = {}
	
	statbar.layer = layer or "HUD"
	statbar.priority = priority or 50
	
	local obj = game.GetGameWorld():createGameObject("GameObject");
	statbar.gameobject = obj
	if parent then
		obj:setParent(parent)
	end
	
	local x = xPos or 0
	local y = yPos or 0
	obj:setPos(x, y)
	
	--------------------------]
	local statCap = 100
	local playerStat = statData.playerStat_
	local equipmentStat = statData.equipmentStat_
	local fatigue = statData.fatigue_
	local statVal = playerStat+equipmentStat
	if (statVal < 0) then
		statVal = 0
	end
	local text = game.getLocalizedText(statData.statName_) .. ": " .. statVal
	
	if( showTempStats == true and statData.statBoost_ > 0 ) then
		text = text .. " (+" .. statData.statBoost_ .. ")"
	end
	--------------------------]
	
	function statbar:recalculate(statData)
		
	end
	
	
	local fatigue_pct = fatigue --/ 100

	if (playerStat + equipmentStat > statCap) then
		equipmentStat = equipmentStat - (statCap - (playerStat + equipmentStat))
	end
	local totalStat = playerStat + equipmentStat
	if (totalStat > 100) then
		totalStat = 100
	end

	local bar_empty = obj:addSpriteSheet( "xml_resources/sprite_menu.xml", "stat_empty", 0, 0, menuScale, menuScale )
	bar_empty:SetLayerByName(statbar.layer)
	bar_empty:SetPriority(statbar.priority)
	bar_empty:center()
	
	local player_pct = (playerStat + statData.statBoost_) / statCap
	--print("playerStat="..player_pct.." statData.statBoost_="..statData.statBoost_.." statCap="..statCap  )
	local equipment_pct = equipmentStat / statCap
	
	local max_width = bar_empty:width()*menuScale
	
	local player_width = math.ceil(bar_empty:width() * player_pct)
	local equipment_width = math.ceil(bar_empty:width() * equipment_pct)
	
	local fatigue_width = math.ceil((player_width + equipment_width) * fatigue_pct)
	equipment_width = equipment_width - fatigue_width

	
	print("player_width "..player_width)
	print("equipment_width "..equipment_width)
	print("fatigue_width "..fatigue_width)
	if (equipment_width < 0) then
		local extra = equipment_width
		equipment_width = 0

		player_width = player_width + extra

		if (player_width < 0) then
			player_width = 0
		end
	end
	
	local pos = player_width+equipment_width
	local bar_fatigue = obj:addSprite( "gfx/menu/common/stat_fatigue", player_width*menuScale+equipment_width*menuScale, 0, menuScale, menuScale )
	bar_fatigue:SetLayerByName(statbar.layer)
	bar_fatigue:SetPriority(statbar.priority-3)
	bar_fatigue:center()
	bar_fatigue:SetMask(player_width+equipment_width, 0, fatigue_width, bar_fatigue:height())

	local bar_player = obj:addSprite( "gfx/menu/common/stat_equipment", 0, 0, menuScale, menuScale )
	bar_player:SetLayerByName(statbar.layer)
	bar_player:SetPriority(statbar.priority-1)
	bar_player:center()
	bar_player:SetMask(0, 0, player_width, bar_player:height())	
	
	local bar_equipment = obj:addSprite( "gfx/menu/common/stat_player", player_width*menuScale, 0, menuScale, menuScale )
	bar_equipment:SetLayerByName(statbar.layer)
	bar_equipment:SetPriority(statbar.priority-2)
	bar_equipment:center()
	bar_equipment:SetMask(player_width, 0, equipment_width, bar_equipment:height())

	local font = font or "zombie_font_description"
	local textGfx = obj:addTextRaster(font, text, 0, 1, 0.4, 0.4)
	textGfx:SetLayerByName(statbar.layer)
	textGfx:center()
	textGfx:SetPriority(statbar.priority-4)
		
	return statbar
end

return StatBar