local itemName, itemDesc = ...

local nameText=itemName
local descText=itemDesc
local rewardValue="rv"

local ActionHelper = include("ActionHelper")
local Button = include("Button")

local StoreEquipmentInfo = {}

local menuScale = game.menuScale()

StoreEquipmentInfo.show = function()

	local obj = game.GetGameWorld():createGameObject("GameObject");
	obj:setTag("StoreEquipmentInfo")

	local basePriority = 20

	local fadedBGObj = game.GetGameWorld():createGameObject("GameObject");
	fadedBGObj:setParent(rootObj)
	fadedBGObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	fadedBGObj:setTag("FadedBG_p")
	
	local fadedBG = fadedBGObj:addSprite("gfx/menu/bg/background")
	fadedBGObj:setScale( lua_sys.screenWidth()/fadedBG:width(), lua_sys.screenHeight()/fadedBG:width() )
	fadedBG:SetLayerByName("POPUP")
	fadedBG:center()
	fadedBG:SetPriority(basePriority)
	fadedBG:SetAlpha(200)
	
	local bg = obj:addSprite("gfx/menu/store/info_popup", 0, 0, menuScale, menuScale)
	bg:SetLayerByName("POPUP")
	bg:center()
	bg:SetPriority(basePriority-1)

	local closeButton = Button.new("xml_resources/sprite_menu.xml", "btn_close", "POPUP", basePriority-5, obj, -175*menuScale, -bg:height()*menuScale * 0.5 + 10*menuScale, true, menuScale)
	closeButton.onTouchUp = function() 
		StoreEquipmentInfo.hide()
	end
	

	local touch = obj:addTouch( lua_sys.screenWidth(), lua_sys.screenHeight(), basePriority-4 )
	touch:setAnchor( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	touch:setEnabled(0)

	local textObj = game.GetGameWorld():createGameObject("GameObject");
	textObj:setTag("StoreEquipmentInfoText")
	
	local objName = textObj:addTextRaster("zombie_font_description", game.getLocalizedText(nameText), 10, -30, 0.7, 0.7, game.GfxText_Format_Center, 355, true )
	objName:SetLayerByName("POPUP")
	objName:center()
	objName:SetPriority(basePriority-2)
	
	local objDesc = textObj:addTextRaster("zombie_font_description", game.getLocalizedText(descText), 10, 10, 0.5, 0.5, game.GfxText_Format_Left, 335, true )
	objDesc:SetLayerByName("POPUP")
	objDesc:center()
	objDesc:SetPriority(basePriority-2)
	
	--[[local objRewardVal = textObj:addTextRaster("zombie_font_description", rewardValue, -40, 20, 0.5, 0.5, game.GfxText_Format_Right, 335, true )
	objRewardVal:SetLayerByName("POPUP")
	objRewardVal:center()
	objRewardVal:SetPriority(basePriority-2)
	
	local rewardSpr = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "gummy_001", 145, 20)
	rewardSpr:SetLayerByName("POPUP")
	rewardSpr:center()
	rewardSpr:SetPriority(basePriority-2)00]]
	
	textObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	textObj:setAlpha(0.0)
	
	obj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	obj:setScale(0.0, 1.0)
	
	local action = obj:moveScale( 1.0, 0, 0.45, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)

	action = textObj:moveAlpha( 1.0, 0.15, lua_sys.Quadratic_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
	
	touch:setEnabled(1)
	
end

StoreEquipmentInfo.hide = function()

	local obj = game.GetGameWorld():getObjectByTag("StoreEquipmentInfo")
	local textObj = game.GetGameWorld():getObjectByTag("StoreEquipmentInfoText")
	local FadedBGObj = game.GetGameWorld():getObjectByTag("FadedBG_p")
	if obj then
		local action = textObj:moveAlpha( -1.0, 0.1, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
	
		action = obj:moveScale( -1.0, 0, 0.25, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		
		game.GetGameWorld():destroyGameObject(textObj)
		game.GetGameWorld():destroyGameObject(FadedBGObj)
		game.GetGameWorld():destroyGameObject(obj)
	end

end

StoreEquipmentInfo.show()