local infoText, upgradeText = ...

local ActionHelper = include("ActionHelper")
local Button = include("Button")

local menuScale = game.menuScale()
local StoreItemInfo = {}

StoreItemInfo.show = function()

	local obj = game.GetGameWorld():createGameObject("GameObject");
	obj:setTag("StoreItemInfo")

	local basePriority = 50

	local bg = obj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_large", 0, 0, menuScale, menuScale)
	bg:SetLayerByName("POPUP")
	bg:center()
	bg:SetPriority(basePriority)

	local closeButton = Button.new("xml_resources/sprite_menu.xml", "btn_close", "POPUP", basePriority-2, obj, -175*menuScale, -bg:height()*menuScale * 0.5 + 10*menuScale, true, menuScale)
	closeButton.onTouchUp = function() 
		StoreItemInfo.hide()
	end

	local touch = obj:addTouch( lua_sys.screenWidth(), lua_sys.screenHeight(), 400 )
	touch:setAnchor( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	touch:setEnabled(0)

	local textObj = game.GetGameWorld():createGameObject("GameObject");
	textObj:setTag("StoreItemInfoText")
		
	local info = textObj:addTextRaster("zombie_font_description", game.getLocalizedText(infoText), 0, -55*menuScale, 0.4*menuScale, 0.4*menuScale, game.GfxText_Format_Center, 355*menuScale, true )
	info:SetLayerByName("POPUP")
	info:center()
	info:SetPriority(basePriority-2)
	
	local upgrade = textObj:addTextRaster("zombie_font_description", game.getLocalizedText(upgradeText), 10*menuScale, -18*menuScale, 0.4*menuScale, 0.4*menuScale, game.GfxText_Format_Left, 335*menuScale, true )
	upgrade:SetLayerByName("POPUP")
	upgrade:center()
	upgrade:SetPriority(basePriority-2)
	
	textObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	textObj:setAlpha(0.0)
	
	obj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	obj:setScale(0.0, 1.0)
	
	local action = obj:moveScale( 1.0, 0, 0.45, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)

	action = textObj:moveAlpha( 1.0, 0.15, lua_sys.Quadratic_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
	
	touch:setEnabled(1)
	
end

StoreItemInfo.hide = function()

	local obj = game.GetGameWorld():getObjectByTag("StoreItemInfo")
	local textObj = game.GetGameWorld():getObjectByTag("StoreItemInfoText")
	if obj then
		local action = textObj:moveAlpha( -1.0, 0.1, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
	
		action = obj:moveScale( -1.0, 0, 0.25, lua_sys.Quadratic_EASEIN )
		action:start()
		ActionHelper.waitForAction(action)
		
		game.GetGameWorld():destroyGameObject(textObj)
		game.GetGameWorld():destroyGameObject(obj)
	end

end

StoreItemInfo.show()