--local rootObj = ...

local ActionHelper = include("ActionHelper")
local Button = include("Button")
local StoreItem = include("StoreItem")
local SwipeComponent = include("SwipeComponent")

local StoreList = {}
local staticObjLayer
local itemObjs = {}
local totalItems = 0

local menuScale = game.menuScale()

ItemCategory = {
	["HAT"] = 0,
	["GLOVE"] = 1,
	["BAT"] = 2,
	["SHIRT"] = 3,
	["PANTS"] = 4,
	["SHOES"] = 5,
	["POWERUP"] = 6,
	["CURRENCY"] = 7
}

StoreList.show = function(categoryID, offsetX, offsetY, cardScale)

	local category = categoryID
	
	local items = game.getStoreItems(category)

	local basePriority = 50
	
	local obj = game.GetGameWorld():createGameObject("GameObject")
	obj:setTag("StoreList")
	obj:setPos( lua_sys.screenWidth(), lua_sys.screenHeight() * 0.5 )
	
	--local offsetX = 15
	--local offsetY = -100
	local spacingY = 130
	StoreList.totalListHeight = 0

	--[[local gfx = obj:addTextRaster( game.getMidSizeFont(), game.getLocalizedText("Store"), 0, -lua_sys.screenHeight()*0.5+25, 0.5, 0.5 )
	gfx:SetLayerByName("HUD")
	gfx:SetPriority(5)
	gfx:center()--]]
	
	--local missionControl = game.getMissionControl()	
	totalItems = items:size()
	for i = 0, items:size()-1, 1 do
		local item = items[i];

		if (item.showInStore_) then
			local pos = 1
			
			local storeitem = StoreItem.new( item, "HUD", basePriority-2, obj, offsetX, offsetY)
			storeitem.onTouchUp = function()
				print "touch up leaderboarditem"
			end
			
			itemObjs[item.id_] = storeitem
			
			offsetY = offsetY + spacingY
			pos = pos + 1
			StoreList.totalListHeight = StoreList.totalListHeight + storeitem.height + (spacingY - storeitem.height )
			print ("function totalListHeight i: "..i.." height:"..StoreList.totalListHeight)
		end
	end
	
	
	
	local swipeComponentHeight = lua_sys.screenHeight() * math.ceil(StoreList.totalListHeight/lua_sys.screenHeight())
	--print ("swipeComponentHeight = "..swipeComponentHeight)
	if( swipeComponentHeight < lua_sys.screenHeight() ) then
		--print ("swipeComponentHeight must be at least the height of the screen")
		swipeComponentHeight = lua_sys.screenHeight()
	end
	
	--width, height, layer, priority, objects, xPos, yPos
	local swipeComp = SwipeComponent.new( lua_sys.screenWidth(), swipeComponentHeight, "HUD", basePriority-1, obj) 

	print ("function totalListHeight: "..StoreList.totalListHeight)
	local upperLimit = (lua_sys.screenHeight() * 0.5) - (StoreList.totalListHeight*menuScale - (320*menuScale*cardScale))
	print( "upperLimit"..upperLimit )
	print( "cardScale"..cardScale )
	print( "menuScale"..menuScale )
	if( upperLimit > lua_sys.screenHeight() * 0.5 ) then
		upperLimit = lua_sys.screenHeight() * 0.5
	end	
		
	swipeComp:setUpperLimit(upperLimit)
	StoreList.swipeLayer = swipeComp;

	staticObjLayer = game.GetGameWorld():createGameObject("GameObject");
	staticObjLayer:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	staticObjLayer:setTag("StaticObjLayer")

	--[[local closeButton = Button.new("xml_resources/sprite_menu.xml", "btn_close", "HUD", basePriority-4, staticObjLayer, -lua_sys.screenWidth()*0.5 + 20, -lua_sys.screenHeight()*0.5+50)
	closeButton.onTouchUp = function() 
		StoreList.hide()
	end--]]

	--[[local continueButton = Button.new("xml_resources/sprite_menu.xml", "btn_green", "HUD", basePriority-4, staticObjLayer, lua_sys.screenWidth()*0.5 - 60, lua_sys.screenHeight()*0.5-30)
	continueButton.gameobject:setTag("ContinueButton")
	continueButton:setText("Continue")
	continueButton.onTouchUp = function() 
		StoreList.playBall = true
		StoreList.hide()
	end--]]
	
	--staticObjLayer:setPos( -lua_sys.screenWidth(), lua_sys.screenHeight() * 0.5 )
	
	local action = obj:movePosition( lua_sys.screenWidth() * 0.5 - obj:x(), 0, 0.75, lua_sys.Back_EASEOUT )
	action:start()
	--local action2 = staticObjLayer:movePosition( lua_sys.screenWidth() * 0.5 - staticObjLayer:x(), 0, 1, lua_sys.Back_EASEOUT )
	--action2:start()
	ActionHelper.waitForAction(action)
	
	return StoreList
end

StoreList.unselectAll = function()
	print("Unselecting StoreList Items...")
	
	for i = 0, totalItems-1, 1 do
		itemObjs[i]:setEquipped(false)
	end
	
	--print("cool!")
end

StoreList.setSelected = function(id)
	--print("neat!")
	
	for i = 0, totalItems-1, 1 do
		if (itemObjs[i].id == id) then
			print ("*********EQUIPPED**********")
			itemObjs[i]:setEquipped(true)
		else
			itemObjs[i]:setEquipped(false)
		end
		
	end
	
	--print("cool!")
end

StoreList.unlockItem = function(id)
	print("Unlocking " .. id)

	for i = 0, totalItems-1, 1 do
		if (itemObjs[i].id <= id) then
			itemObjs[i]:setLocked(false, true)
		else
			--itemObjs[i]:setLocked(false)
		end
		
	end
end

StoreList.hide = function()

	local obj = game.GetGameWorld():getObjectByTag("StoreList")
	--local staticObjLayer = game.GetGameWorld():getObjectByTag("StaticObjLayer")
	
	if obj then
		local action = obj:movePosition( lua_sys.screenWidth() - obj:x(), 0, 0.3, lua_sys.Quadratic_EASEIN )
		action:start()
		local action2 = staticObjLayer:movePosition( -lua_sys.screenWidth() - obj:x(), 0, 0.3, lua_sys.Quadratic_EASEIN )
		action2:start()
		ActionHelper.waitForAction(action)
		game.GetGameWorld():destroyGameObject(obj)
		
		if( StoreList.totalListHeight > 0 ) then
			SwipeComponent.destroy()
		end
		
		if staticObjLayer  then
			game.GetGameWorld():destroyGameObject(staticObjLayer)
		end
		
	else
		print("Where'd options go?")
	end

end

--StoreList.show()
return StoreList