
local ActionHelper = include("ActionHelper")
local Button = include("Button")
--local PopupStatInfo = include("PopupStatInfo")

local menuScale = game.menuScale()
local StorePurchasePopup = {}

ItemCategory = {
	["HAT"] = 0,
	["GLOVE"] = 1,
	["BAT"] = 2,
	["SHIRT"] = 3,
	["PANTS"] = 4,
	["SHOES"] = 5,
	["POWERUP"] = 6,
	["CURRENCY"] = 7
}

StorePurchasePopup.new = function( price, parent, item, limit, isIAP, name, premium, data )

	local storepurchasepopup = {}
	
	function storepurchasepopup:tick() 
		print "tick..."
	end
	
	storepurchasepopup.obj = game.GetGameWorld():createGameObject("GameObject");
	storepurchasepopup.obj:setTag("StorePurchasePopup")
	
	--local obj = game.GetGameWorld():createGameObject("GameObject");
	--obj:setTag("StorePurchasePopup")

	local basePriority = 20

	local fadedBGObj = game.GetGameWorld():createGameObject("GameObject");
	--fadedBGObj:setParent(parent)
	fadedBGObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	fadedBGObj:setTag("FadedBG_SPP")
	
	local fadedBG = fadedBGObj:addSprite("gfx/menu/bg/background")
	fadedBGObj:setScale( lua_sys.screenWidth()/fadedBG:width(), lua_sys.screenHeight()/fadedBG:width() )
	fadedBG:SetLayerByName("POPUP")
	--fadedBG:SetScale(1.5, 1.5)
	fadedBG:center()
	--fadedBG:SetPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5)
	--fadedBG:SetPos( lua_sys.screenWidth() * 0.75, lua_sys.screenHeight() * 0.75)
	fadedBG:SetPriority(basePriority)
	fadedBG:SetAlpha(200)
	
	local bg = storepurchasepopup.obj:addSpriteSheet("xml_resources/sprite_menu.xml", "box_medium", 0, 0, menuScale, menuScale)
	bg:SetLayerByName("POPUP")
	bg:center()
	bg:SetPriority(basePriority-1)
	
	
	
	local icon = "coin_gold"
	if (premium or isIAP) then
		icon = "coin_platinum"
		print("it is premium or IAP")
	end
	
	local moneyIcon = storepurchasepopup.obj:addSpriteSheet("xml_resources/sprite_menu.xml", icon, -45*menuScale, 30*menuScale, menuScale, menuScale)
	moneyIcon:SetLayerByName("POPUP")
	moneyIcon:SetPriority(basePriority-4)
	moneyIcon:center()
	

	local closeButton = Button.new("xml_resources/sprite_menu.xml", "btn_close", "POPUP", basePriority-2, storepurchasepopup.obj, -175*menuScale, -bg:height()*menuScale * 0.5 + 10*menuScale, true, menuScale)
	closeButton.onTouchUp = function() 
		StorePurchasePopup.resume = true
		StorePurchasePopup.hide()
	end

	local touch = storepurchasepopup.obj:addTouch( lua_sys.screenWidth(), lua_sys.screenHeight(), basePriority )
	touch:setAnchor( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	touch:setEnabled(1)
	
	local mainButton = Button.zone("POPUP", basePriority-1, storepurchasepopup.obj, 0, 0, lua_sys.screenWidth(), lua_sys.screenHeight())
	print("setting spam delay to 100")
	mainButton:setSpamDelay(75)
	print("done setting spam delay to 100")
	mainButton.onTouchUp = function() 
		StorePurchasePopup.hide()
	end



	local priceObj = game.GetGameWorld():createGameObject("GameObject");
	priceObj:setTag("StorePurchasePopupText")
	

	local textGfx = priceObj:addTextRaster("zombie_font_description", game.getLocalizedText("CONFIRM_PURCHASE"), 10*menuScale, -13*menuScale, 0.5*menuScale, 0.5*menuScale, game.GfxText_Format_Center, 300*menuScale, true )
	textGfx:SetLayerByName("POPUP")
	textGfx:center()
	textGfx:SetPriority(basePriority-2)
	
	nameText = priceObj:addTextRaster("zombie_font_description", name, 0, -38, 0.6, 0.6, game.GfxText_Format_Center, 250)
	nameText:SetLayerByName("POPUP")
	nameText:center()
	nameText:SetPriority(basePriority-3)

	
	local buyButton = Button.new("xml_resources/sprite_menu.xml", "btn_green", "POPUP", basePriority-2, storepurchasepopup.obj, 0, bg:height()*menuScale * 0.30, true, menuScale)
	if (isIAP) then
		buyButton:setText("$" .. (price/100))
	else
		buyButton:setText("" .. price)
	end
	buyButton.onTouchUp = function() 
		print("StorePurchase PopUp buy button onTouch up")
		if (item.category == ItemCategory["CURRENCY"]) then
			if ( game.buyRealItem(data.itemGroupName_, item.id) ) then
				StorePurchasePopup.hide()
				--game.addPlatinumCoins( data.stack_ )
			end
			return
		end
	
		if (item.bought) then
			game.equipItem(item.category, item.id)
			return
		end
	
		if ( game.purchaseItem(item.category, item.id) ) then
		
			if (limit > 0) then
				item:setBought(true)
				item:setEquipped(true)
			end
			
			game.playSfx("audio/sfx/cash_register.wav");
			print("Purchasing item id[" .. item.id .. "] from category [" .. item.category .. "]")
			StorePurchasePopup.hide()
			
			if (game.showPowerupTutorial() and item.category == ItemCategory["POWERUP"]) then
				game.showPopupPowerupInfo()
				game.disablePowerupTutorial()
			elseif( game.showPlayerStatsTutorial() and item.hasBonus ) then
				game.showPopupStatInfo()
				game.disablePlayerStatsTutorial()
			end
		else
			print("Not enough currency to buy!")
			print "not enough gold"
			StorePurchasePopup.hide(false)
			if (premium or isIAP) then
				local inStore = 1
				game.showNoMoneyPrompt(inStore)
			else
				print "not enough gold"
				game.showNoGoldMoneyPrompt(price)
			end
			
		end
	end
	
	-- animate
	priceObj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	priceObj:setAlpha(0.0)
	
	storepurchasepopup.obj:setPos( lua_sys.screenWidth() * 0.5, lua_sys.screenHeight() * 0.5 )
	storepurchasepopup.obj:setScale(0.0, 1.0)
	
	local action = storepurchasepopup.obj:moveScale( 1.0, 0, 0.45, lua_sys.Back_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)

	action = priceObj:moveAlpha( 1.0, 0.15, lua_sys.Quadratic_EASEOUT )
	action:start()
	ActionHelper.waitForAction(action)
	
	return storepurchasepopup
end

-- Animations to close the menu
StorePurchasePopup.hide = function( animate )
	
	if animate == nil then
		animate = true
	end
	
	local obj = game.GetGameWorld():getObjectByTag("StorePurchasePopup")
	local textObj = game.GetGameWorld():getObjectByTag("StorePurchasePopupText")
	local FadedBGObj = game.GetGameWorld():getObjectByTag("FadedBG_SPP")
	if obj then
	
		if( animate == true ) then
			local action = textObj:moveAlpha( -1.0, 0.1, lua_sys.Quadratic_EASEIN )
			action:start()
			ActionHelper.waitForAction(action)
		
			action = obj:moveScale( -1.0, 0, 0.25, lua_sys.Quadratic_EASEIN )
			action:start()
			ActionHelper.waitForAction(action)
		end
		
		StorePurchasePopup.timeLeft = 0
		game.GetGameWorld():destroyGameObject(textObj)
		game.GetGameWorld():destroyGameObject(FadedBGObj)
		game.GetGameWorld():destroyGameObject(obj)
	end
end

return StorePurchasePopup

