-- Toggle Button

ToggleButton = {}

local function waitForInput( button )

	while true do
		
		local event = nil
	
		coroutine.yield({
			button.gameobject, 
			game.M_MsgGameObjectTouchEvent_GetMsgTypeId(),
			function(msg) 
				event = msg.event -- need to capture the event because we can't yield from here
				return true 
			end
		})
		
		if event == game.TouchEvent_Down then
		
			button.isDown = true
		
		elseif event == game.TouchEvent_Cancel then
			
			button.isDown = false
		
		elseif button.isDown and event == game.TouchEvent_Up then
		
			button.isDown = false
			button:toggle()
			
		end

		event = nil
			
	end


end

ToggleButton.new = function(sheet, off_name, on_name, layer, priority, scale)

	local button = {}
	button.layer = layer or "HUD"
	button.priority = priority or 50
	
	button.scale = 1.0
	if( scale ~= nil ) then
		button.scale = scale
	end
	
	local obj = game.GetGameWorld():createGameObject("GameObject");
	button.gameobject = obj
	
	local spr = obj:addSpriteSheet( sheet, on_name, 0, 0, button.scale, button.scale )
	spr:SetLayerByName(button.layer)
	spr:SetPriority(button.priority)
	spr:center()
	button.onSprite = spr
	
	local spr = obj:addSpriteSheet( sheet, off_name, 0, 0, button.scale, button.scale )
	spr:SetLayerByName(button.layer)
	spr:SetPriority(button.priority)
	spr:center()
	button.offSprite = spr
	
	button.touch = obj:addTouch( button.onSprite:width()*button.scale, button.onSprite:height()*button.scale, button.priority )
	button.touch:setAnchor( button.onSprite:width() * 0.5 * button.scale, button.onSprite:height() * 0.5 * button.scale)
	
	--defaults to off
	button.on = false
	button.onSprite:SetVisible(false)
	button.offSprite:SetVisible(true)
	
	function button:toggle()
		self.on = not self.on
		self.onSprite:SetVisible(self.on)
		self.offSprite:SetVisible(not self.on)
		if self.onToggle then
			self:onToggle()
		end
	end
	
	button.updateToggle = function(toggle)
		button.on = toggle
		button.onSprite:SetVisible(button.on)
		button.offSprite:SetVisible(not button.on)
		print "goodbye"
	end
	
	--would be nice if we could run the coroutine (lua function) on a gameobject
	RunIndyCoroutine( waitForInput, button )
	
	return button

end


return ToggleButton


