precision mediump float;

varying lowp vec4 v_Color;
varying vec2 v_TexCoordinate;

uniform sampler2D u_Texture; // the texture with the scene you want to blur
uniform sampler2D u_alpha;

uniform float blurSize; // size of a single pixel for the blursize (1/(width or height))
 
void main(void)
{
   lowp vec4 sum = vec4(0.0);
 
   // blur in x and y (should probably be two different shaders)
   // take 13 samples, with the distance blurSize between them
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x - 6.0*blurSize, v_TexCoordinate.y)) * 0.04;
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x - 5.0*blurSize, v_TexCoordinate.y)) * 0.05;
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x - 4.0*blurSize, v_TexCoordinate.y)) * 0.06;
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x - 3.0*blurSize, v_TexCoordinate.y)) * 0.08;
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x - 2.0*blurSize, v_TexCoordinate.y)) * 0.1;
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x - blurSize, v_TexCoordinate.y)) * 0.11;
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x, v_TexCoordinate.y)) * 0.12;
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x + blurSize, v_TexCoordinate.y)) * 0.11;
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x + 2.0*blurSize, v_TexCoordinate.y)) * 0.1;
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x + 3.0*blurSize, v_TexCoordinate.y)) * 0.08;
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x + 4.0*blurSize, v_TexCoordinate.y)) * 0.06;
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x + 5.0*blurSize, v_TexCoordinate.y)) * 0.05;
   sum += texture2D(u_Texture, vec2(v_TexCoordinate.x + 6.0*blurSize, v_TexCoordinate.y)) * 0.04;
 
   gl_FragColor = sum;
}